package org.vishia.odt.readOdt;

import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Stack;
import java.util.TreeMap;

import javax.imageio.ImageIO;

import org.vishia.msgDispatch.LogMessage;
import org.vishia.msgDispatch.LogMessageStream;
import org.vishia.util.Arguments;
import org.vishia.util.Debugutil;
import org.vishia.util.ExcUtil;
import org.vishia.util.FileFunctions;
import org.vishia.util.StringFunctions;
import org.vishia.util.StringFunctions_C;
import org.vishia.util.StringPart;
import org.vishia.xmlReader.XmlCfg;
import org.vishia.xmlSimple.XmlSequWriter;
import org.vishia.zip.ZipUtils;


public class WriteOdt extends TranslateOdtCommon {

  
  public static class CmdArgs extends TranslateOdtCommon.CommonArgs {
    
    File dirDbg;
    
 //   String sName, sExtIn;
    
    /**True then read adoc, false specific markup. */
    boolean bReadAdoc;
    
    /**A configuartion file to read. */
    File fCfg;
    
    
    //String sExtLabel;
    
    
    /**An XML file to write. */
    File fOutXml;
    
    
    /**If a www link starts with this, replace also the absolute link if an anchor is replaced.
     * 
     */
    String swwwRoot = "XXX";  // initialvalue not found in sRef
    
    /**If not null then write some report info. */
    File fReport;
    

    /**If true then call {@link GenXmlCfgJavaData} with the used existing XmlCfg. */
    File dirCreateCfgJavaData;
    
    /**If true then write with the only one read #fIn a new analyzed XmlCfg to this file. */
    File fWriteXmlStruct;
    
    float pixelPerPageWidth = 1024;
    
    /**If true then it tries to rename an image with that name which is given in title. 
     * This is helpful for example if an exporter writes "Img12.png" with current number and the images should have a proper name.
     */
    boolean bRenameImageFiles = false;
    
    /**Default false, set to true with -extRefs. Decides to write a list of all extern references to related docu. 
     * This is currently not recommended. This information are also available in the *.Labels.txt files,
     * see {@link TranslateOdtCommon.CommonArgs#dirLabel} and argument -labels:...*/
    boolean bWriteExternRefs = false;
    
    /**This array describes the commands with its help and stores the result to CmdArgs. More is not necessary. 
     * @since 2023-09-23 moved from {@link org.vishia.fbcl.readSmlk.GenSmlk2FBcl}, there was using the older concept with {@link org.vishia.mainCmd.MainCmd.Arguments}
     *   now proper to {@link Arguments}. This list is possible, alternatively to direct instantiating in ctor.
     * */
    Argument[] argList1 = {
          new Argument("-cfg", ":<path/file.cfg> a plain text file with config entries", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            CmdArgs.this.fCfg = new File(val).getAbsoluteFile();  
            return CmdArgs.this.fCfg.exists();
          }})
        , new Argument("-i", ":<path/file.mu.adoc> markup file for input", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            int posWildcard = val.indexOf('*');
            int posName = val.lastIndexOf('\\')+1;
            int posName2 = val.lastIndexOf('/')+1;
            if(posName2 > posName) { posName = posName2; }
            int posDot = val.lastIndexOf('.');
            CmdArgs.this.sNameMarkup = posWildcard == posName ? CmdArgs.this.sNameMarkup : val.substring(posName, posDot);
            CmdArgs.this.sExtMarkup = val.substring(posDot);
            CmdArgs.this.dirIn = new File(posName == 0 ? "." : val.substring(0, posName)).getAbsoluteFile();
            CmdArgs.this.fIn = new File(CmdArgs.this.dirIn, CmdArgs.this.sNameMarkup + CmdArgs.this.sExtMarkup).getAbsoluteFile();  
            return CmdArgs.this.fIn.exists();
          }})
        , new Argument("-a", ":<path/file.adoc>  pure asciidoc file for input", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            CmdArgs.this.fIn = new File(val).getAbsoluteFile(); 
            CmdArgs.this.dirIn = CmdArgs.this.fIn.getParentFile();
            CmdArgs.this.bReadAdoc = true;
            return CmdArgs.this.fIn.exists();
          }})
        , new Argument("-r", ":<path/file.txt>  file for report", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            int posWildcard = val.indexOf('*');
            int posName = val.lastIndexOf('\\')+1;
            int posName2 = val.lastIndexOf('/')+1;
            if(posName2 > posName) { posName = posName2; }
            int posDot = val.indexOf('.', posName);
            if(posWildcard <0) { CmdArgs.this.sNameDoc = val.substring(posName, posDot); }
            String sExt = val.substring(posDot);
            File dir = new File(posName == 0 ? "." : val.substring(0, posName)).getAbsoluteFile();
            CmdArgs.this.fReport = new File(dir, CmdArgs.this.sNameDoc + sExt).getAbsoluteFile();  
            return CmdArgs.this.fReport.getParentFile().exists();
          }})
        , new Argument("-oxml", ":<path/XMLOUT>  file.xml instead -odt:<ODT> extension .xml will be automatically append", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            String path = val.endsWith(".xml") ? val : val + ".xml";
            CmdArgs.this.fOutXml = new File(path).getAbsoluteFile();  
            return CmdArgs.this.fOutXml.getParentFile().exists();
          }})
        , new Argument("-odt", ":<path/ODT>  file.odt for odt output", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            int posWildcard = val.indexOf('*');
            int posName = val.lastIndexOf('\\')+1;
            int posName2 = val.lastIndexOf('/')+1;
            if(posName2 > posName) { posName = posName2; }
            int posDot = val.indexOf('.', posName);
            if(posWildcard <0) { CmdArgs.this.sNameDoc = val.substring(posName, posDot); }
            CmdArgs.this.sExtOut = val.substring(posDot);
            CmdArgs.this.dirOut = CmdArgs.super.dirOut = new File(posName == 0 ? "." : val.substring(0, posName)).getAbsoluteFile();
            CmdArgs.this.fOut = CmdArgs.super.fOut = new File(CmdArgs.this.dirOut, CmdArgs.this.sNameDoc + CmdArgs.this.sExtOut).getAbsoluteFile();  
            return CmdArgs.this.fOut.exists();
          }})
        , new Argument("-www", ":<wwwRoot>>  root for www access to replace operation link anchors", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            CmdArgs.this.swwwRoot = val;  
            return true;
          }})
        , new Argument("-genJavaData", ":<path>  Generates new versions of Java data in pkg path from -analyzeXmlStruct or from given XmlCfg", new SetArgument(){ 
          @Override public boolean setArgument(String val) throws IOException { 
            File dirJava = new File(val).getAbsoluteFile();
            if(!dirJava.exists() || !dirJava.isDirectory()) {
              return CmdArgs.this.errMsg("-genJavaData:%s ERROR not found as directory", dirJava );
            } else {
              CmdArgs.this.dirCreateCfgJavaData = dirJava;
              return true;
          }}})
        , new Argument("-extRefs", " write external references", new SetArgument() {
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            CmdArgs.this.bWriteExternRefs = true;  
            return true;
          }})
        , new Argument("-analyzeXmlStruct", ":D:/path/to/xmlCfg.txt optional, first analyze the input xml data and generate a new XmlCfg text file", new SetArgument() {
          @Override public boolean setArgument(String val) throws FileNotFoundException { 
            CmdArgs.this.fWriteXmlStruct = new File(val) ;  
            File dirWriteXmlStruct = CmdArgs.this.fWriteXmlStruct.getParentFile();
            FileFunctions.mkDir(dirWriteXmlStruct);
            return dirWriteXmlStruct.exists();
          }})
      };
    
    
    CmdArgs(){
      super();
      super.aboutInfo = "...Reader content from odg for FunctionBlockGrafic";
      super.helpInfo="obligate args: -o:... ...input";
      for(Argument arg: this.argListCommon) { addArg(arg); }
      for(Argument arg: this.argList1) { addArg(arg); }
    }
  
    @Override public boolean testConsistence ( Appendable msg ) {
      boolean bOk = true;
      if(this.fOutXml == null) {
        File dirXml = this.dirDbg !=null ? this.dirDbg : this.fIn.getParentFile();
        this.fOutXml = new File(dirXml, "content.xml");
      }
      try {
        if(false) { msg.append("-dirFBcl:path/to/outdir is obligate\n"); bOk = false; }
      } catch(IOException exc) {
        System.err.println("Fatal Error, msg as Appendable has IOException " + exc.getMessage());
      }
      if(!bOk) {
        super.showHelp(msg);
      }
      return bOk;
    }
  }

  
  
  
  private static class Cfg {
    
    boolean useItalicBold;
    
    String sImgCaptionStart = "Figure ";
    String sImgCaption2 = ": ";
    int eImgKindNr = 1;
  }
  
  
  
  
  
  
  
  /**main for this class, with given prepared arguments 
   * Does not catch unexpected exceptions and does not System.exit(...), use it to execute in a Java environment. 
   * @param args prepared cmd line arguments
   * @return 0 if all is ok
   * @throws IOException 
   * @throws Exception if unexpected.
   */
  public static int amain ( CmdArgs args) throws IOException {
    WriteOdt thiz = new WriteOdt(args);
    thiz.execute();
    return 0;
  }
  
  
  
  
  
  /**main gets the arguments as String, 
   * but does not catch unexpected exceptions and does not System.exit(...), use it to execute in a Java environment. 
   * @param sArgs
   * @return 0 if all is ok
   * @throws IOException 
   * @throws Exception if unexpected.
   */
  public static int smain ( String[] sArgs, Appendable logHelp, Appendable logError) throws IOException {
    CmdArgs args = new CmdArgs();
    if(sArgs.length ==0) {
      args.showHelp(logHelp);
      return(1);                // no arguments, help is shown.
    }
    if(  ! args.parseArgs(sArgs, logError)
      || ! args.testConsistence(logError)
      ) { 
      return(2);                    // argument error
    }
    //LogMessageStream log = new LogMessageStream(System.out);
    int exitCode = amain(args);
    System.out.printf("\n*** finished %s @%s", args.fOut.getName(), args.fOut.getParent()  );
    System.out.printf(" EXIT-code=%d", exitCode);
    System.out.println();
    return exitCode;
  }
  
  
  
  /**main for WriteOdt, invoked from cmd line. 
   * Catch and report an unexpected exceptions via console error output, returns an exit code 
   * @param sArgs
   * @return 0 if all is ok
   */
  public static void main ( String[] sArgs) { //Test include VML: <::main.>
    try {
      int exitCode = smain(sArgs, System.out, System.err);  //<:@exit.>
      System.exit(exitCode);
    } catch (Exception e) {                 //    <:@exc.>
      System.err.println("Unexpected: " + e.getMessage()); //<:-main.>
      e.printStackTrace(System.err);
      System.exit(255);                     //<:+main.>
    }
  } //<:.main.>


  final CmdArgs args;
  
  
  final Cfg cfg = new Cfg();
  
  final XmlCfg xmlCfgOdt = new XmlCfg(true);
  
  BufferedReader rAdoc;
  
  Stack<BufferedReader> stack_rAdoc = new Stack<>();
  
  //private static int nBookmarkDefault = 100;
  
  /**Last read line from aDoc. */
  String sLineNext;
  
  /**>=1 then the deepness of nesting paragraph nodes. */
  int XXXnParagr;
  
  
  /**If not null then a <code>[.style] was read.
   * Valid for the next paragraph.
   */
  String sStyleParagr;
  
  
  /**true only immediately after set &lt;text:p ...>*/
  boolean bParagrFirstline;
  
  /**>=1 then the deepness of nesting section nodes. */
  int nSection;
  
  /**>=1 then the deepness of nesting list nodes. */
  int nList;
  
  /**true then a &lt;text:list-item... is opened in the moment. */
  boolean bInsideListItem;
  
  /**True then a "'''" was seen before. It is in html an horizontal line. 
   * It means the next paragraph makes a page break or column break: */
  boolean bPageBreakBefore, bColumnBreakBefore;
  
  boolean bInsideColumn2;
  
  int nrSectionName =0;
  
  int nrTableName =0;
  
  int nrFrameImgName =0;
  
  /**Index of all foreign book marks (adequate option -labels:*.Labels.text)
   * filled from this files.
   * See {@link #readLabelFile(File, String)}.
   * This index is used for {@link #writeChapterRef(String)} and {@link #writeInternalRefPage(String)}
   * to write the external link. */
  Map<String, ReadOdt.LabelRef> idxLabelExternRef = new TreeMap<String, ReadOdt.LabelRef>();
  
  /**Same content as {@link #idxLabelExternRef} but sorted to document and chapter numer
   * to write out {@link #writeExternReferences()}. */
  Map<String, ReadOdt.LabelRef> idxChnrExternRef = new TreeMap<String, ReadOdt.LabelRef>();
  
  
  /**If set (not null) then the next lines till "----" should be written as &lt;text:p... with this style.
   * It is for code snippets.
   */
  String sCodeStyle;
  
  boolean bInsideCode;
  
  
  /**It is set if a ref to bookmark was created.
   * Use the same bookmark to create a page ref.
   * 
   */
  String sRefBookmark;
  
  /**Stores a [#label] for the next header or paragraph. */
  String sXXXLabel;

  final StringBuilder sbo = new StringBuilder(16384);
  
  private Writer wrRep;
  
  /**Opened writer to write the label file.*/
  //private Writer wrLabel;
  
  /**The last anchor which is replaced for operation arguments. */
  private String lastAnchorReplaced = "";
  
  final XmlSequWriter xmlWr = new XmlSequWriter();
  
  
  protected WriteOdt(CmdArgs args) {
    super(new LogMessageStream(null, null, System.out, System.err, false, Charset.forName("UTF-8")));
    this.args = args;
 
  }

  
  private void wrRep(CharSequence line) throws IOException {
    if(this.wrRep !=null) {
      this.wrRep.append(line).append("\n");
    }
  }
  

  
  
  public void execute() throws IOException {
    
    if(this.args.dirLabel !=null) {
      List<File> listFiles = new LinkedList<>();
      FileFunctions.addFileToList(this.args.dirLabel, this.args.sNameLabel, listFiles);
      for(File fLabel: listFiles) {
        String name = fLabel.getName();
        name = name.substring(0, name.indexOf('.'));
        if(!name.equals(this.args.sNameDoc)) {  // do not read the own label file
          readLabelFile(fLabel, name);
        }
      }
      //this.wrLabel = new OutputStreamWriter(new FileOutputStream(new File(this.args.dirLabel, this.args.sName)), "UTF-8");
    }
    
    
    
    //------------------------------------------------------- read cfg, same as for parse odt, for namespace declaration:
    this.xmlCfgOdt.readFromJar(WriteOdt.class, "xmlCfgOdtNonSemantic.txt", this.log);
    //
    if(this.args.fCfg !=null) {    //======================== read some config data from file.
      InputStream fCfg = new FileInputStream(this.args.fCfg);
      Arguments.readConfig(this.cfg, fCfg, null, this.log);
      fCfg.close();
    }
    //
    this.rAdoc = new BufferedReader(new InputStreamReader(new FileInputStream(this.args.fIn), "UTF-8"));
    
    this.wrRep = this.args.fReport == null ? null :new OutputStreamWriter(new FileOutputStream(this.args.fReport), "UTF-8");
   
    //TODO-2 may read first styles.xml from -outOdt to check it.    
    //
    this.xmlWr.open(this.args.fOutXml, "UTF-8", this.sbo);  // foutXml is either in -dbgdir or manual given or it is content.xml
    try {
      this.xmlWr.writeElement("office:document-content");
      for(Map.Entry<String, String > eNs  : this.xmlCfgOdt.iterNamespace()) {
        String ns = eNs.getKey();
        String alias = eNs.getValue();
        String key = "xmlns:" + alias;
        this.xmlWr.writeAttribute(key, ns);
      }
      this.xmlWr.writeElement("office:scripts");
      this.xmlWr.writeElementEnd();
      this.xmlWr.writeElement("office:font-face-decls");
      this.xmlWr.writeElementEnd();
      this.xmlWr.writeElement("office:automatic-styles");
      writeStyleSections();
      this.xmlWr.writeElementEnd();
      this.xmlWr.writeElement("office:body");
      this.xmlWr.writeElement("office:text");
      this.xmlWr.writeElement("text:sequence-decls");
      this.xmlWr.writeElementEnd();
    } catch(Exception exc) {
      this.log.writeError("Unexpected, will close xml and odt: ", exc);
      this.xmlWr.writeText(exc.getMessage(), true);
    }
    do {            //======================================= loop for possible opened included files
      try {
        parseVmlWriteOdt();
      } catch(Exception exc) {
        this.log.writeError("Unexpected, will close xml and odt: ", exc);
        this.xmlWr.writeText(exc.getMessage(), true);
      }
      this.rAdoc.close();
      if(this.stack_rAdoc.isEmpty()) {
        this.rAdoc = null;
      } else {
        this.rAdoc = this.stack_rAdoc.pop();
      }
    } while(this.rAdoc !=null);
    if(this.xmlWr.elementCurrTag().equals("text:section")) { 
      this.xmlWr.writeElementEnd("text:section");
    }
    if(this.args.bWriteExternRefs) {
      writeExternReferences();
    }
    this.xmlWr.writeElementEnd("office:text");
    this.xmlWr.writeElementEnd("office:body");
    this.xmlWr.writeElementEnd("office:document-content");
    this.xmlWr.close();
    if(this.wrRep !=null) {
      this.wrRep.append("\n");
      this.wrRep.close();
      this.wrRep = null;
    }
//    if(this.wrLabel !=null) {
//      this.wrLabel.append("\n");
//      this.wrLabel.close();
//      this.wrLabel = null;
//    }
    //======================================================= if fOutOdt is given, then writes back
    writeBackupFile(this.args);
    if(this.args.fOut !=null) {                         //  the new created fOutXml to the odt zip archiv.: 
      ZipUtils.replaceFile(this.args.fOut.getAbsolutePath(), this.args.fOutXml.getAbsolutePath(), "content.xml");
    }
  }
  
  
  
  private String switchToInclude(String sFileArg) throws IOException {
    BufferedReader rIncl = null;
    int posEnd = sFileArg.indexOf(".>");
    String sNameInclude = sFileArg.substring(0, posEnd);
    File fInclude = new File(this.args.dirIn, sNameInclude);
    if(!fInclude.exists()) {
      this.log.writeError("ERROR include file not found: %s @%s", sNameInclude, this.args.dirIn.getPath());
    } else {
      try {
        rIncl = new BufferedReader(new InputStreamReader(new FileInputStream(fInclude), "UTF-8"));
      } catch (Exception exc) {
        this.log.writeError("ERROR include file Exception: ", exc);
      }
    }
    if(rIncl !=null) {
      this.log.writef("\nRead included: %s", sNameInclude);
      this.stack_rAdoc.push(this.rAdoc);                   // save the BufferedReader for using later again.
      this.rAdoc = rIncl;                                  // now it continues in this opened file.
      String line;
      while( (line = this.rAdoc.readLine()) !=null) {      // skip over all lines before includeStart
        if(line.startsWith("<:@includeStart.>")) {
          break;                                           // skip over all lines till inclusively "<:@includeStart.>"
        }
        else if(line.startsWith("== ")) {
          break;
        }
      }
    } else {                           //-------------------- on error in include file continue with the given
      assert(true);                                        // TODO write a message in the document.
    }
    return null;
  }
  

  
  private void readLabelFile(File fLabel, String nameRefFile) {
    try {
      BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(fLabel), "UTF-8"));
      String line;
      while((line = r.readLine()) !=null) {
        if(line.startsWith("#")) {
          int posSpace = line.indexOf(' ');
          String sLabel = line.substring(1, posSpace);
          int posPage = line.lastIndexOf('@');
          if(!sLabel.startsWith("?") && posPage >=0) {
            String sTitle = line.substring(posSpace+1, posPage).trim();
            String sPage = line.substring(posPage+1).trim();
            ReadOdt.LabelRef labelRef = this.idxLabelExternRef.get(sLabel);
            if( labelRef !=null) {
              if(labelRef.idxLabel.get(sLabel) !=null) {
                this.log.writef("\n#%s already contained in bookmarks: >>%s<<, new: >>%s<<", sLabel, this.idxLabelExternRef.get(sLabel), sTitle);
              } else {
                labelRef.idxLabel.put(sLabel, sLabel);
              }
            } else {
              List<String> listLabel = new LinkedList<>();
              listLabel.add(sLabel);
              labelRef = new ReadOdt.LabelRef(nameRefFile, null, listLabel, sTitle, sPage);
              this.idxLabelExternRef.put(sLabel, labelRef);
              this.idxChnrExternRef.put(nameRefFile + sTitle, labelRef); // assume sTitle has a number on start, then sorted by this nr
            }
          }
        }
      }
      r.close();
    } catch (IOException exc) {
      System.err.print("\nERROR reading " + fLabel.getAbsolutePath());
    }
    
  }
  
  
  
  private void writeStyleSections () throws IOException {
    //======================================================= SectTOC as section style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "SectTOC");    // Note: section styles are not part of style sheets
    this.xmlWr.writeAttribute("style:family", "section");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:section-properties");
    this.xmlWr.writeAttribute("style:editable", "false");
    this.xmlWr.writeElement("style:columns");
    this.xmlWr.writeAttribute("fo:column-count", "1");
    this.xmlWr.writeAttribute("fo:column-gap", "0mm");
    this.xmlWr.writeElementEnd("style:columns");  //style:columns
    this.xmlWr.writeElementEnd("style:section-properties");  //style:section-properties
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= SectTOCc as section style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Contents_20_Heading_pg");    // Note: section styles are not part of style sheets
    this.xmlWr.writeAttribute("style:family", "paragraph");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeElementEnd("style:paragraph-properties");  //style:section-properties
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= Column2 as section style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Column2");    // Note: section styles are not part of style sheets
    this.xmlWr.writeAttribute("style:family", "section");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:section-properties");
    this.xmlWr.writeAttribute("text:dont-balance-text-columns", "false");
    this.xmlWr.writeAttribute("style:editable", "false");
    this.xmlWr.writeElement("style:columns");
    this.xmlWr.writeAttribute("fo:column-count", "2");
    this.xmlWr.writeAttribute("fo:column-gap", "7mm");
    this.xmlWr.writeElement("style:column");
    this.xmlWr.writeAttribute("style:rel-width", "32767*");
    this.xmlWr.writeAttribute("fo:start-indent", "0mm");
    this.xmlWr.writeAttribute("fo:end-indent", "3.5mm");
    this.xmlWr.writeElementEnd();
    this.xmlWr.writeElement("style:column");
    this.xmlWr.writeAttribute("style:rel-width", "32768*");
    this.xmlWr.writeAttribute("fo:start-indent", "3.5mm");
    this.xmlWr.writeAttribute("fo:end-indent", "0mm");
    this.xmlWr.writeElementEnd();
    this.xmlWr.writeElementEnd();  //style:columns
    this.xmlWr.writeElementEnd();  //style:section-properties
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= Title_pg as paragraph style with page break before and start with page1 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Title_pg1");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Title");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeAttribute("style:master-page-name", "First_20_Page");  // use standard LOffc "First Page"
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeAttribute("style:page-number", "1");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H2pg as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H2pg");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_2");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H3pg as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H3pg");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_3");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H4pg as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H4pg");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_4");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H5pg as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H5pg");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_5");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "page");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H3col as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H3col");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_3");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "column");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H4col as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H4col");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_4");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "column");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= H5col as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "H5col");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Heading_20_5");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElement("style:paragraph-properties");
    this.xmlWr.writeAttribute("fo:break-before", "column");
    this.xmlWr.writeElementEnd("style:paragraph-properties");
    this.xmlWr.writeElementEnd("style:style");  //style:style

    //======================================================= text_List1 as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "text_List1");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Text");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeAttribute("style:list-style-name", "List_20_1");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= text_List2 as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "text_List2");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Text");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeAttribute("style:list-style-name", "List_20_2");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= text_List3 as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "text_List3");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Text");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeAttribute("style:list-style-name", "List_20_3");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= text_List4 as heading style with page break before 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "text_List4");       // Note: Should refer the parent style Headind_20_2 
    this.xmlWr.writeAttribute("style:family", "paragraph");  // 
    this.xmlWr.writeAttribute("style:parent-style-name", "Text");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeAttribute("style:list-style-name", "List_20_4");  // Can only be provide as direct style in office:automatic-styles
    this.xmlWr.writeElementEnd("style:style");  //style:style
    //======================================================= italic text style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "modif_i");
    this.xmlWr.writeAttribute("style:family", "text");
    this.xmlWr.writeElement("style:text-properties");
    this.xmlWr.writeAttribute("fo:font-style", "italic");  
    this.xmlWr.writeAttribute("fo:font-style-asian", "italic");  
    this.xmlWr.writeAttribute("fo:font-style-complex", "italic");  
    this.xmlWr.writeElementEnd("style:text-properties");
    this.xmlWr.writeElementEnd("style:style");
    //======================================================= bold text style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "modif_b");
    this.xmlWr.writeAttribute("style:family", "text");
    this.xmlWr.writeElement("style:text-properties");
    this.xmlWr.writeAttribute("fo:font-weight", "bold");  
    this.xmlWr.writeAttribute("fo:font-weight-asian", "bold");  
    this.xmlWr.writeAttribute("fo:font-weight-complex", "bold");  
    this.xmlWr.writeElementEnd("style:text-properties");
    this.xmlWr.writeElementEnd("style:style");
    //======================================================= italic bold text style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "modif_ib");
    this.xmlWr.writeAttribute("style:family", "text");
    this.xmlWr.writeElement("style:text-properties");
    this.xmlWr.writeAttribute("fo:font-style", "italic");  
    this.xmlWr.writeAttribute("fo:font-style-asian", "italic");  
    this.xmlWr.writeAttribute("fo:font-style-complex", "italic");  
    this.xmlWr.writeAttribute("fo:font-weight", "bold");  
    this.xmlWr.writeAttribute("fo:font-weight-asian", "bold");  
    this.xmlWr.writeAttribute("fo:font-weight-complex", "bold");  
    this.xmlWr.writeElementEnd("style:text-properties");
    this.xmlWr.writeElementEnd("style:style");
    //======================================================= table style 
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Table1");
    this.xmlWr.writeAttribute("style:family", "table");
    this.xmlWr.writeElement("style:table-properties");
    this.xmlWr.writeAttribute("style:width", "8.9cm");  
    this.xmlWr.writeAttribute("table:align", "margins");  
    this.xmlWr.writeElementEnd("style:table-properties");
    this.xmlWr.writeElementEnd("style:style");
    //
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Table1.A");
    this.xmlWr.writeAttribute("style:family", "table-column");
    this.xmlWr.writeElement("style:table-column-properties");
    this.xmlWr.writeAttribute("style:column-width", "1.78cm");  
    this.xmlWr.writeAttribute("style:rel-column-width", "13107*");  
    this.xmlWr.writeElementEnd("style:table-column-properties");
    this.xmlWr.writeElementEnd("style:style");
    //
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "Table1.A1");
    this.xmlWr.writeAttribute("style:family", "table-cell");
    this.xmlWr.writeElement("style:table-cell-properties");
    this.xmlWr.writeAttribute("fo:padding", "0cm");  
    this.xmlWr.writeAttribute("fo:border", "none");  
    this.xmlWr.writeAttribute("style:writing-mode", "page");  
    this.xmlWr.writeElementEnd("style:table-cell-properties");
    this.xmlWr.writeElementEnd("style:style");
    //
    //------------------------------------------------------- Graphic
    this.xmlWr.writeElement("style:style");
    this.xmlWr.writeAttribute("style:name", "ImgFromTop");
    this.xmlWr.writeAttribute("style:family", "graphic");
    this.xmlWr.writeAttribute("style:parent", "Img");
    this.xmlWr.writeElement("style:graphic-properties");
    this.xmlWr.writeAttribute("style:vertical-pos", "from-top");  
    this.xmlWr.writeAttribute("style:vertical-rel", "paragraph");  
    this.xmlWr.writeAttribute("style:horizontal-pos", "center");  
    this.xmlWr.writeAttribute("style:horizontal-rel", "paragraph-content");  
    this.xmlWr.writeElementEnd("style:graphic-properties");
    this.xmlWr.writeElementEnd("style:style");
  }
  
  
  
  public void parseVmlWriteOdt () throws IOException {
    String line;
    do {
      if(this.sLineNext !=null) {
        line = this.sLineNext; this.sLineNext = null;
      } else {
        line = this.rAdoc.readLine();
      }
      if(line !=null) {
        int pos = line.length();
        while(--pos >=0 && line.charAt(pos) == ' ' );
        pos +=1;
        if(pos < line.length()) {
          line = line.substring(0, pos);   //------------------ remove trailing spaces generally
        }
        if(this.args.bReadAdoc) {
          parseAdocLine(line);
        } else {
          parseAdocM(line);
        }
      }
    } while(line !=null); 
    XXXfinitParagr();
  }
  
  
  
  private static String[] specificLineStarts = { "*", "//", "<:td.>", "<:tr.>", "<.table>"};
  

  
  
  
  /**Parse a new line for paragraph etc, not the continued lines from a paragraph.
   * @param line found line
   * @return
   * @throws IOException
   */
  protected String parseAdocLine (String line) throws IOException {
    String error = null;
    if(line.startsWith("It should be presumed that"))
      Debugutil.stop();
    if(line.length() >=1) {
      char c1 = line.charAt(0); 
      if(c1 !='*' && this.nList >0) {
        finitList(0);
      }
      switch(c1) {
      case ':': break;       // ctrl for Adoc generation
      case '[': return parseWriteParagrStyleLabel(line);
      case '=': return writeHeaderLine(line);
      case '/': return checkParseCommentLine(line);
      //case '\'': return checkParsePageColumnBreak(line);
      case '*': return parseList(line);
      case ' ': return parseWriteCodeBlock(line);
      default: 
        if(line.startsWith("image::")) return parseImage(line, true);
        else if(line.startsWith("----")) return parseWriteCodeBlock(line);
        else return parseWriteParagr(line, null);
      }
    }
    return error;
  }
  
  
  /**Parse a new line for paragraph etc, not the continued lines from a paragraph.
   * @param line found line
   * @return
   * @throws IOException
   */
  private String parseAdocM (String line) throws IOException {
    String error = null;
    if(line.startsWith("It should be presumed that"))
      Debugutil.stop();
    if(line.length() >=1) {
      char c1 = line.charAt(0); 
      if(c1 !='*' && this.nList >0) {
        finitList(0);
      }
      switch(c1) {
      case '=': return writeHeaderLine(line);
      case '*': return parseList(line);
      default: 
        if(line.startsWith("##")) return null; //comment internal
        //if(line.startsWith("<:image:")) return parseImage(line);
        if(line.startsWith("<:Code:")) return parseWriteCodeBlock(line);
        if(line.startsWith("<::TOC-")) return writeTableOfContents(line.substring(7));
        if(line.startsWith("<::pageBreak.>")) { this.bPageBreakBefore = true; return null; }
        if(line.startsWith("<::columnBreak.>")) { this.bColumnBreakBefore = true; return null; }
        if(line.startsWith("<:p:")) return parseWriteParagrStyleLabel(line);
        if(line.startsWith("<::table")) return parseWriteTable(line);
        if(line.startsWith("<::Section:")) return parseWriteSection(line);
        if(line.startsWith("<.Section>")) return writeSectionEnd(line);
        if(line.startsWith("<:@include:")) return switchToInclude(line.substring(11));
        else return parseWriteParagr(line, null);
      }
    }
    return error;
  }
  
  
  private boolean isEmptyLine (String line, int fromPos) {
    if(line == null) return true;
    int nLine = line.length();
    for(int ix = fromPos; ix < nLine; ++ix) {
      if(" \t".indexOf(line.charAt(ix)) <0) return false;
    }
    return true;
  }
  
  
  private String writeHeaderLine(String lineArg) throws IOException {
    StringBuilder allLines = readAllTextLinesOfParagraph(lineArg);
    String line = allLines.toString();
    finitList(0);
    String error = null;
    if(line.contains("One letter for the base type"))
      Debugutil.stop();
    if(this.nSection >0)
      Debugutil.stop();
    int zLine = line.length();
    int pos = 0;
    while(++pos < zLine && line.charAt(pos) == '=');       // skips over all ===, pos is first pos after ===
    int nHeader = pos -1;                                  // level of the header 0 = only one "="
    char cc;
    while( pos < zLine && ( (cc = line.charAt(pos)) =='.' || cc >='0' && cc <= '9' || cc == ' ')) {
      pos +=1; }
//    if(this.bPageBreakBefore)
//      Debugutil.stop();
    final String sTitle;
    int posLabel = line.indexOf("<:#");
    List<String> labels = new LinkedList<>();
    if(posLabel >0) {
      sTitle = line.substring(pos, posLabel).trim();
      int posLabelEnd;
      do {
        posLabelEnd = line.indexOf('>', posLabel);
        if(posLabelEnd >0) {
          if(line.charAt(posLabelEnd-1) == '.') { posLabelEnd -=1; }
          labels.add(line.substring(posLabel + 3, posLabelEnd)); 
        }                                                  // loop if more labels one after another <:#labelnew.> <:#labelOld.>
      } while( posLabelEnd > 0 && (posLabel = line.indexOf("<:#", posLabelEnd)) >0);
    } else {
      sTitle = line.substring(pos).trim();
    }
    if(sTitle.length()==0) {
      this.log.writef("\nWARNING empty %s found, ignored", line);
    } else {
      String style = nHeader ==0 ? "Title" 
                   : this.bPageBreakBefore && nHeader >1       // Heading_20_1 is always with page break. Not an extra 
                   ? "H" + nHeader + "pg" 
                   : this.bColumnBreakBefore && nHeader >1       // Heading_20_1 is always with page break. Not an extra 
                   ? "H" + nHeader + "col" 
                   : "Heading_20_" + nHeader;
      this.bPageBreakBefore = this.bColumnBreakBefore = false; // flag is only for this paragraph
      this.xmlWr.writeElement("text:h");
      this.xmlWr.writeAttribute("text:style-name", style);
      this.xmlWr.writeAttribute("text:outline-level", "" + nHeader);
      this.bParagrFirstline = true;
      ListIterator<String> iterLabels = labels.listIterator();
      while(iterLabels.hasNext()) { iterLabels.next(); }  // got after last element
      while(iterLabels.hasPrevious()) {
        String sLabel = iterLabels.previous();
        this.xmlWr.writeElementInline("text:bookmark-start");
        this.xmlWr.writeAttribute("text:name", "__Link_" + sLabel);
        this.xmlWr.writeElementEnd("text:bookmark-start");
      }
      error = parseWriteText(sTitle, false);
      //parseParagrNextLine(line.substring(pos +1));
      for(String sLabel: labels) {  
      //for(String sLabel: labels) {  
        this.xmlWr.writeElementInline("text:bookmark-end");
        this.xmlWr.writeAttribute("text:name", "__Link_" + sLabel);
        this.xmlWr.writeElementEnd("text:bookmark-end");
      }
      this.sXXXLabel = null;
      this.xmlWr.writeElementEndInline("text:h");
      
      wrRep(line);
    }
    return error;
  }
  
  
  private String checkParseCommentLine(String line) throws IOException {
    int nLine = line.length();
    //if(nLine <2 || !(line.charAt(1)=='/')) return parseParagrNextLine(line);         // a line not with "//" is not a comment
    if(line.startsWith("//Section:")) {
      parseWriteSection(line);
    }
    else if(line.startsWith("//End-Section")) {
      writeSectionEnd(line);
    }
    else if(line.startsWith("//TOC-")) {
      writeTableOfContents(line.substring(6));
    }
    String error = null;
    return error;
    
  }
  
  
  
  private String parseWriteSection(String line) throws IOException {
    int posSection = line.indexOf(':', 3);  // 3: do not find "<:Sec..."
    int pos2 = line.indexOf('>');
    if(pos2 <0) { pos2 = line.length(); }
    String sSect = line.substring(posSection+1, pos2).trim();
    if(sSect.startsWith("Column")) {
      this.bInsideColumn2 = true;
    }
    finitList(0);
    this.xmlWr.writeElement("text:section");
    this.xmlWr.writeAttribute("text:style-name", sSect);
    this.xmlWr.writeAttribute("text:name", "Section" + (++this.nrSectionName));
    this.nSection +=1;
    return null;
  }

  
  
  private String writeSectionEnd(String line) throws IOException {
    if(this.nSection >0) {
      finitSection(this.nSection-1);
      this.bInsideColumn2 = false;
    }
    return null;
  }

  
  

  private String parseWriteParagrStyleLabel(String line) throws IOException {
    String error = null;
    //int nLine = line.length();
    char cEnd = this.args.bReadAdoc ? ']' : '>';
    int pos9 = line.indexOf(cEnd);
    if(pos9 <0) return "ERROR in Asciidoc, missing "+ cEnd + " in line: " + line;
    if(line.charAt(pos9-1) == '.') { pos9 -=1; }
    String sLabel = null;
    if(!this.args.bReadAdoc) {     //------------------------- MUv: <:p: style : #label >
      int posLabel = line.indexOf(":", 4);
      if(posLabel >=0 && posLabel < pos9) {
        sLabel = line.substring(posLabel +1, pos9).trim();
        pos9 = posLabel;
      }
      this.sStyleParagr = line.substring(4, pos9).trim();
    } else if(line.startsWith("[.")) { //-------------------- Adoc: [.style] it is a special paragraph format
        String style = line.substring(2,pos9);
      this.sStyleParagr = style;
    }
    else if(line.startsWith("[Source,")) {     //------------ Adoc: [source, style] a source block
      this.sCodeStyle = line.substring(8, pos9).trim();
    }
    else if(line.startsWith("[#")) {          //------------- Adoch: [#Label]
      sLabel = line.substring(2, pos9).trim();
    }
    int posNext = line.charAt(pos9) == '.' ? pos9+2 : pos9+1;
    String sLineRest = line.substring(posNext).trim();
    
    return parseWriteParagr(sLineRest, sLabel);
  }
  
  
  /**
   * @param line This is only the start (first) line. All other lines will be read here
   *   calling {@link #readAllTextLinesOfParagraph(String)}
   * @param sLabel null or a label (bookmark) for this paragraph TODO not implemented yet.
   * @return
   * @throws IOException
   */
  private String parseWriteParagr(String line, String sLabel) throws IOException {
    if(line.startsWith("LibreOffice and Asciidoc are two very different approaches"))
      Debugutil.stop();
    String error = null;
    finitList(0);
    this.xmlWr.writeElement("text:p");
    if(this.bColumnBreakBefore)
      Debugutil.stop();
    if(this.sStyleParagr ==null) {
      this.sStyleParagr = this.bPageBreakBefore ? "TextPg" : this.bColumnBreakBefore ? "TextCol" : "Text";
    }
    this.bPageBreakBefore = this.bColumnBreakBefore = false; // flag is only for this paragraph
    this.bParagrFirstline = false; // because it writes immediately the first line.
    StringBuilder allLines = readAllTextLinesOfParagraph(line);
    error = parseWriteText(allLines, false);

    this.xmlWr.writeElementEndInline("text:p");
    return error;
  }
  
  
  
  
  
  private String parseList (String line) throws IOException {
    String error = null;
    //finitParagr();
    if(this.bInsideListItem) {
      this.xmlWr.writeElementEnd("text:list-item");
      this.bInsideListItem = false;
    }
    int nLine = line.length();
    int pos = 0;
    while(++pos < nLine && line.charAt(pos) == '*');       // skips over all ===, pos is first pos after ===
    int nList = pos;
    while(this.nList < nList) {
      this.nList +=1;
      this.xmlWr.writeElement("text:list");
      this.xmlWr.writeAttribute("text:style-name", "List_20_" + this.nList);
      this.xmlWr.writeElement("text:list-item");
      this.bInsideListItem = true;
    }
    if(!this.bInsideListItem) {
      this.xmlWr.writeElement("text:list-item");
      this.bInsideListItem = true;
    }
    finitList(nList); 
    this.xmlWr.writeElement("text:p");
    this.xmlWr.writeAttribute("text:style-name", "text_List" + this.nList);
    this.XXXnParagr = 0;
    this.bParagrFirstline = true;
    if(line.length()> pos+1) {
      StringBuilder allLines = readAllTextLinesOfParagraph(line.substring(pos+1));
      error = parseWriteText(allLines, false);
    }
    this.xmlWr.writeElementEndInline("text:p");
    this.xmlWr.writeElementEnd("text:list-item");
    this.bInsideListItem = false;
    return error;
  }
  
  
  /**
   * https://op.europa.eu/de/web/eu-vocabularies/formex/physical-specifications/character-encoding/quotation-marks
   */
  static String[][] sTextReplace = 
    { {  "\\",     "\\\\", "\\"   }     //backslash itself, detect first to prevent first detect one backslash and a following char.
    , {  "<:",     "<\\:", "<:" }       //Special replacement for <: in text
    , {  "<.",     "<\\.", "<." }       //Special replacement for <. in text
    , {  ".>",     ".\\>", ".>" }       //Special replacement for .> in text
    , {  "\uff0d", "\\---", "{fmin}" }  //Fullwidth Hyphen-Minus, dash    －     https://en.wikipedia.org/wiki/Halfwidth_and_Fullwidth_Forms_(Unicode_block)
    , {  "\u2013", "\\--", "{fmin}" }   //width Hyphen-Minus, dash –             //?? https://jakubmarian.com/hyphen-minus-en-dash-and-em-dash-difference-and-usage-in-english/
    , {  "\u00a0", "\\ ", "{nbsp}" }    //non breaking space
    , {  "\u2008", "\\:", "{dsp}" }     //space width as a dot
    , {  "\u200b", "\\|", "{zwsp}" }    //no width optional break
    , {  "\n",     "\\n ", " +\n"   }   //! executes <text:line-break>
    , {  "\t",     "\\t ", "{tab}"   }  //! executes insert tab
    , {  "\u2060", "\\+", "{wj}"   }    //word joiner, no break here possible
    , {  "\u2011", "\\-", "{nbhy}" }    //non breaking hyphen
    , {  "\u00ad", "\\~", "{zhy}" }     //soft hyphen, possible hyphenation
    , {  "\u00ab", "\\<<", "{ldaquo}"   }  //left pointing guillemet (ISO: left-pointing double angle quotation mark)
    , {  "\u00bb", "\\>>", "{rdaquo}"   }  //right pointing guillemet (ISO: right-pointing double angle quotation mark)
    , {  "\u2039", "\\<", "{lsaquo}" }  //single left angle quotation mark
    , {  "\u203a", "\\>", "{rsaquo}" }  //single right angle quotation mark
    , {  "\u201c", "\\\"", "{ldquo}"}   // English left, German right quotation 
    , {  "\u201d", "\\''", "{rdquo}"}   // English right double quotation 
    , {  "\u2018", "\\'", "{lsquo}"}   // 
//    , {  "\u201f", "\\``", "{rxdquo}"}  // ?? 
    , {  "\u2019", "\\^", "{rsquo}"}    // right single quotation
//    , {  "\u201b", "\\`", "{lsrquo}"}   // single reversed comma quotation mark
    , {  "\u201e", "\\,,", "{lbdquo}"}  // German double low quotation mark 
    , {  "\u201a", "\\,", "{llsquo}"}   // low single comma quotation mark
    , {  "\u2017", "\\_", "{rxdquo}"}   // double underliner   xxx ?? 
    , {  "\u2023", "\\*>", "*"}         // bullet point triangle to right
    , {  "\u25cf", "\\**", "*"}         // bullet point larger
    , {  "\u2022", "\\*", "*"}          // bullet point standard
    };
  
  
  /**Single characters to replace with {@link #sTextReplace} proper for StringFunctions# 
   * 
   */
  static String sTextReplaceChars; // = "\\\u00a0\u2008\u2060\u2011\u00ad\uff0d\u2039\u203a\u00ab\u00bb\u2018\u2019\u201a\u201b\u201c\u201d\u201e\u201f";
  static {
    char[] cc = new char[sTextReplace.length];
    int ix = -1;
    for(String[] check: sTextReplace ) {
      cc[++ix] = check[0].charAt(0);
    }
    sTextReplaceChars = new String(cc);
  }
  

  
  /**This Strings are replaced from Asciidoc to LibreOffice.
   * It means if Asciidoc contains it, they will be replaced with the UTF-16 character or UTF-8 used for LibreOffice
   * but they are not replaced backward.
   * It means for generated Asciidoc UTF-8 should be used in editor and files. 
   * 
   */
  static String[][] sTextReplaceAsciidoc = 
    { { " " , "\0", "{sp}"   }
    , { "'" , "\\0", "{apos}" }
    , { "\"", "\\0", "{quot}" }
    , { "°" , "\\0", "{deg}"  }
    , { "+" , "\\0", "{plus}" }
    , { "|" , "\\0", "{vbar}" }
       
    };
  
  static String[][] sCheckReplace = new String[ WriteOdt.sTextReplace.length 
                                                + WriteOdt.sTextReplaceAsciidoc.length]
                                                [];
  static { 
    int ix=-1;
    for(String[] check : WriteOdt.sTextReplace) {
      sCheckReplace[++ix] = check;
    }
    for(String[] check : WriteOdt.sTextReplaceAsciidoc) {
      sCheckReplace[++ix] = check;
    }
  }

  
  /**Builds the search Strings for replacing from VMU to character in {@link #sTextReplace} [0].*/
  static String[] sCheckTextReplVmu = new String[ WriteOdt.sTextReplace.length ];
  static { 
    int ix=-1;
    for(String[] check : WriteOdt.sTextReplace) {
      sCheckTextReplVmu[++ix] = check[1];
    }
  }

      
  static String[][] sTextCtrlCommon = 
    { { "<:i:", ".>", "__", "__", "modif_i"}
    , { "<:b:", ".>", "**", "**", "modif_b"}               // A citation is using a particular idea that you got from another author.
    , { "<:ib:", ".>", "__**", "**__", "modif_ib"}         // A quotation is using the exact words of another author.
    , { "<:I:", ".>", "[I]`", "`", "Citation"}             // Note that some people refer to a "citation" as a "paraphrase."
    , { "<:Q:", ".>", "[Q]`", "`", "Quotation"}            // https://cegepenglish.zendesk.com/hc/en-us/articles/204546435-What-is-the-Difference-Between-a-Quotation-and-a-Citation
    , { "<:E:", ".>", "[E]`", "`", "Emphasis"}
    , { "<:S:", ".>", "[S]`", "`", "Strong_20_Emphasis"}
    , { "<:2:", ".>", "[?]`", "`", "Superscript"}
    , { "<:1:", ".>", "[=]`", "`", "Subscript"}
    , { "<:c:", ".>", "`", "`", "ccode"}
    , { "<:@ref:", ".>", "<<#", ">>", "!llink"}
    , { "<:#", ".>", "<<#", ">>", "!llink"}
    , { "<:@link:", ".>", "link:", "]", "!glink"}
    , { "<:@image:", ".>", "image::", "]", "!image"}
    , { "\0", "\0", "pass:[", "]", "!pass"}
    , { "\0", "\0", "+", "+", "!pass+"}
    , { "<:@page:", ".>", "PDF@", "99","!plink"}
    , { "<:@page", ".>", "PDF@", "99","!plink"}
    , { "<:", ".>", "[", "`", "!Tstyle"}
    , { "  ", "", "  ", "", "!spaces"}                   // to detect more as one space one after another.
    };
  
  
  
  /**Contains the Strings to search in Markup source to replace with function or style..
   * It is the {@link #sTextCtrlCommon}[...][0]
   */
  static String[] sTextCtrlCommonSearchMu = new String[sTextCtrlCommon.length];
  static {
    int ix = -1;
    for(String[] s : sTextCtrlCommon) {
      sTextCtrlCommonSearchMu[++ix] = s[0];
    }
  }
  
  
  
  /**Contains the Strings to search in Markup source to replace with function or style..
   * 
   */
  static String[] sTextCtrlCommonSearchAsciidoc = new String[sTextCtrlCommon.length];
  static {
    int ix = -1;
    for(String[] s : sTextCtrlCommon) {
      sTextCtrlCommonSearchAsciidoc[++ix] = s[2];
    }
  }
  
  
  
  
  
  /**Reads all text lines till empty line or till specific such as "* " for a list.
   * @param sLineStart The first line.
   * @return StringBuilder with all lines. 
   *   A read line which is not used is stored in {@link #sLineNext} for using for the next paragraph, especially a list.
   * @throws IOException
   */
  private StringBuilder readAllTextLinesOfParagraph(String sLineStart) throws IOException {
    if(sLineStart.startsWith("The element"))
      Debugutil.stop();
    StringBuilder sbLine = new StringBuilder(512);
    String sLine = sLineStart;
    if(sLineStart !=null) { 
      if(!this.args.bReadAdoc) { sLine = sLineStart.trim(); }  // without especially leading spaces, remove intendation, but not for Asciidoc
      sbLine.append(sLine); 
    }
    do {               //length() is 0 on first call, do not insert a space if line before ends with .>
      boolean bSpace = sLine.length() >0 && !sLine.endsWith("::");
//      if(!bSpace)
//        Debugutil.stop();
      sLine = this.rAdoc.readLine();
      if(isEmptyLine(sLine,0)) {                    // an empty line is the end of the paragraph
        sLine = null;
      } else {
        if(!this.args.bReadAdoc) { sLine = sLine.trim(); } // without especially leading spaces, remove indendation, but not for Asciidoc
        for(String sStart : specificLineStarts) { //--------- check specific line starts also inside consequently lines
          if(sLine.startsWith(sStart)) {                   // abort the paragraph lines if another kind of line comes.
            this.sLineNext = sLine;                        // store the read line for next evaluation.
            sLine = null;
            break;   
          }
        }
      }
      if(sLine !=null) {   //----------------------- paragraph lines are aborted here.
        if(bSpace) { sbLine.append(' '); }
        sbLine.append(sLine);
      }
    } while(sLine !=null);
    return sbLine;
  }
  
  

  /**Analyzes the given line where interpretation are necessrary, and writes it with &lt:text:span... > in the given line, 
   * writes the text with {@link #writeText(String, boolean)} outside interpreations stuff.
   * Which is regarded: see {@link #sTextCtrlCommon}, {@link #sTextCtrlItalicBold}, {@link #sTextCtrlStyleForItalicBold}.
   * The {@link Cfg#useItalicBold} decides whether <code>__textInItalic__</code> etc. is outputted as indirect style italic 
   * or as direct style "Quotation". Both is possible.
   * @param line
   * @return
   * @throws IOException
   */
  private String parseWriteText(CharSequence clineArg, boolean bIndentSpaces) throws IOException {
    int posText = 0;
    CharSequence cline = clineArg; //replaceBackslasSubscription(clineArg, null);   //====>> replace all \" etc.
    //String line = cline.toString();    // it is a cheap operation if cline is a string.
    StringBuilder line = cline instanceof StringBuilder ? (StringBuilder) cline: new StringBuilder(cline);
    if(line.toString().startsWith("LibreOffice and Asciidoc are two very different approaches"))
      Debugutil.stop();
    int ixTransscriptedInTextReplace = this.args.bReadAdoc ? 2 : 1;
    int pos = 0;
    int posEnd = line.length();
    if(StringFunctions.startsWith(line, " "))   //----------- if the paragraph or span begins with spaces,
      posText = writeSpaceSupplement(line);                // then always (also on one space) write <text:s ..../>
    if(line.indexOf("etc.")>=0)
      Debugutil.stop();
    int p1;
    if( (p1 = line.indexOf("etc."))>=0)
      Debugutil.stop();
    int[] ixFound = new int[1];
    do {
      int posTextEnd = posEnd;
      int posTextSpan = -1, posTextEndSpan = -1;
      int posTextNext = posEnd;
      String style = null;

      int pos3, pos4;
      //----------------------------------------------------- check base style/replacing possibility in sTextCtrls:
      
      String[] sFound = new String[1];    //----------------- search one of "<:I:", "<:C:", <:@ref:" etc. inside the text.
      int pos1 = StringFunctions.indexOfAnyString(line, posText, posEnd, sTextCtrlCommonSearchMu, ixFound, sFound);
      if(pos1 >=0) {                      //----------------- found, then 
        String[] check = sTextCtrlCommon[ixFound[0]];
        posTextSpan = pos1 + check[0].length();
        int pos2 = StringFunctions.indexOf(line, posTextSpan, posEnd, check[1]);
        if(pos2 >=0) {
          style = check[4];            //<<<<---------------- The content after this start code till end code, usual till ".>"
          posTextEnd = pos1;                               // pos of the non span text before and after.
          posTextEndSpan = pos2;
          posTextNext = pos2 + check[1].length();
        }
      }
      if(this.sStyleParagr !=null && ( style == null || !style.equals("!image") 
           || posTextEnd > posText || posTextNext < posEnd)
        ) {
        this.xmlWr.writeAttribute("text:style-name", this.sStyleParagr);
        this.sStyleParagr = null;
      }
      if(posTextEnd > posText) {     //---------------------- write the text before <:... or the whole text
        CharSequence textw = replaceBackslasSubscription(line.substring(posText, posTextEnd), null);
        writeText(textw, bIndentSpaces);
      }
      if(style !=null) { //posTextSpan < posTextEndSpan) {    //--------------- <:span:...> found
//        String sSpanTest = line.substring(posTextSpan, posTextEndSpan);
//        if(sSpanTest.contains("\\\\**"))
//          Debugutil.stop();
        String sSpan = replaceBackslasSubscription(line.substring(posTextSpan, posTextEndSpan), null).toString();
        char cStyle = style.charAt(0);                     // is it necessary to convert the sSpan with BackslashSubscription?
        if(cStyle == '*' || cStyle == '+') {
          this.xmlWr.writeText(sSpan, false);              // result of pass:[textSpan]
        } else if(style.charAt(0) == '!') {  //============== starting with "!..." it is a specific handling
          switch(style.charAt(1)) {
          case 'l': writeChapterRef(sSpan); break;        // <:@ref:#  --> "!llink" Note: sSpan without # though given
          case 'p': writeInternalRefPage(sSpan); break;    // <:@page:  --> "!plink" Note: sSpan with # if reference given
          case 'g': writeLink(sSpan);; break;              // "!plink"
          case 'i': {                                      // "!image"
            boolean bOnlyImage = this.sStyleParagr !=null    // it has not a started paragraph before
                              && posTextNext == posEnd;      // and no more follows.
              parseImage(sSpan, bOnlyImage);
          } break;         
          case 'T': {          //------------------------------ "!Tstyle"
            int posStyle2 = StringFunctions.indexOf(line, posTextSpan, posTextEndSpan, ':');
            if(posStyle2 >0) {
              String style1 = line.substring(posTextSpan, posStyle2);
              this.xmlWr.writeElementInline("text:span");
              this.xmlWr.writeAttribute("text:style-name", style1);
              CharSequence textw = replaceBackslasSubscription(line.substring(posStyle2+1, posTextEndSpan), null);
              //String text = line.substring(posStyle2+1, posTextEndSpan);
              writeText(textw, bIndentSpaces);                // do not check content again, write text inside span as given. 
              this.xmlWr.writeElementEnd("text:span");
            }
          } break;
          case 's':                                        // "!spaces"
            posTextNext = posTextEnd + writeSpaceSupplement(line.substring(posTextEnd)); break;
          } //switch
        }
        else {         //------------------------------------ not starting with "!...", it is a style
          this.xmlWr.writeElementInline("text:span");
          this.xmlWr.writeAttribute("text:style-name", style);
          parseWriteText(sSpan, bIndentSpaces);
          this.xmlWr.writeElementEnd("text:span");
        }
        
      }
      posText = posTextNext;
    } while(posText < posEnd);
    if(posText < posEnd) {
      CharSequence textw = replaceBackslasSubscription(line.substring(posText), null);
      writeText(textw, false);
    }
    return null;
  }
  
  
  
  private int writeSpaceSupplement(CharSequence spaces) throws IOException {
    int end = 0;
    int zSpaces = spaces.length();
    while(end < zSpaces && spaces.charAt(end) == ' ') { end +=1; }
    this.xmlWr.writeElementInline("text:s");
    this.xmlWr.writeAttribute("text:c", "" + (end));
    this.xmlWr.writeElementEnd("text:s");
    return end;
  }
  
  
  
  /**Writes a link to a chapter due to &lt;@ref:Label:....>.
   * It checkes {@link #idxLabelExternRef} {@link #idxChnrExternRef}
   * @param refArg
   * @throws IOException
   */
  private void writeChapterRef (String refArg) throws IOException {
    try {
      int posSep = refArg.indexOf(this.args.bReadAdoc ? ',' : ':');    // Adoc: <<#ref,text>>  Mu: <:ref:#ref:text.>
      String ref = (posSep >0 ? refArg.substring(0, posSep) : refArg);
      if(!ref.startsWith("#")) {
        this.log.writef("\nWARNING <:@ref:%s without # is ignored.", refArg);
      } else {
        this.sRefBookmark = ref;
        ref = ref.substring(1);  // use ist without starting "#..."
        ReadOdt.LabelRef labelRef = this.idxLabelExternRef.get(ref); // try fist with immediately given reference
        String sHref = ref;
        boolean bImgRef = ref.startsWith("__Img_");          // Image refs should start with __Img_
        if(!bImgRef && !ref.startsWith("__Link_")) {         // Chapter ref may start with __Link_ 
          ref = "__Link_" + ref;                             // nor __Img_ and _Link_: need the __Link_
        }
        if(labelRef == null) { 
          labelRef = this.idxLabelExternRef.get(ref);
          sHref = ref;
        }
        String text = posSep >0 ? refArg.substring(posSep+1) : refArg;
        if(labelRef !=null) {   //=========================== The bookmark is found in one of the "-labels:files"
          writeChapterRefExtern(sHref, labelRef);
        } else {                //=========================== internal chapter ref
          this.xmlWr.writeElementInline("text:span");
          this.xmlWr.writeAttribute("text:style-name", "Reference");
          if(!bImgRef) {               //-------------------------- Image reference needs no chapter ref because non automatic number incrementation.
            this.xmlWr.writeElementInline("text:bookmark-ref");  // but chapter ref needs it, 
            this.xmlWr.writeAttribute("text:reference-format", "chapter"); // format = "chapter"
            this.xmlWr.writeAttribute("text:ref-name", ref);
            this.xmlWr.writeText("7", false);
            this.xmlWr.writeElementEnd("text:bookmark-ref");
            this.xmlWr.writeElementInline("text:s");
            this.xmlWr.writeElementEnd("text:s");
          }
          this.xmlWr.writeElementInline("text:bookmark-ref");
          this.xmlWr.writeAttribute("text:reference-format", "text");
          this.xmlWr.writeAttribute("text:ref-name", ref);
          this.xmlWr.writeText(text, false);
          this.xmlWr.writeElementEnd("text:bookmark-ref");
          this.xmlWr.writeElementEndInline("text:span");
        }
      }
    } catch(Exception exc) {      //========================= should be used as template for all how to write unexpected Exceptions. 
      CharSequence sExc = ExcUtil.exceptionInfo("", exc, 0, 20);
      this.log.writef("\nException %s", sExc);
      sExc = ExcUtil.exceptionInfo("Exception: ", exc, 0, 2);
      this.xmlWr.writeElementInline("text:span");
      this.xmlWr.writeAttribute("text:style-name", "Emphasis");
      writeText("Exception: ", false);   //NOTE replace \\ etc. not done here
      writeText(sExc, false);   //NOTE replace \\ etc. not done here
      this.xmlWr.writeElementEndInline("text:span");
    }
   
  }
  
  
  private void writeChapterRefExtern (String sHrefArg, ReadOdt.LabelRef labelRef) throws IOException {
    try {
      // Note: the ../ is necessary inside LOffc, additional to the link from the odt file.
      String sHref = this.args.sRefBesideHtml != null ? this.args.sRefBesideHtml + labelRef.sRefHeading + this.args.sExtRefBesideHtml + "#" + sHrefArg 
                   : null;
      String sHwww = this.args.sRefBesideInWWWHtml != null ? this.args.sRefBesideInWWWHtml + labelRef.sRefHeading + this.args.sExtRefBesideHtml + "#" + sHrefArg
                   : null;
      String sPDFref = this.args.sRefBesidePdf == null ? null
                     : this.args.sRefBesidePdf + labelRef.sRefHeading + this.args.sExtRefBesidePdf;
      String sPDFwww = this.args.sRefBesideInWWWPdf == null ? null
                     : this.args.sRefBesideInWWWPdf + labelRef.sRefHeading + this.args.sExtRefBesidePdf;
      if( (sPDFref !=null || sPDFwww !=null) //-------------- write extra 'html' with html link if pdf link exists.
       && sHref !=null || sHwww !=null) {                    //            // and also the href link exists.
        this.xmlWr.writeElementInline("text:a");  //XXRef
        this.xmlWr.writeAttribute("xlink:type", "simple");
        this.xmlWr.writeAttribute("xlink:href", sHref !=null ? sHref : sHwww);
        this.xmlWr.writeAttribute("text:style-name", "Internet_20_link");
        this.xmlWr.writeAttribute("text:visited-style-name", "Visited_20_Internet_20_Link");
        writeText("html", false);
        this.xmlWr.writeElementEnd("text:a");
        if(sHwww !=null && sHref !=null ) {
          writeText(" (", false);
          this.xmlWr.writeElementInline("text:a");
          this.xmlWr.writeAttribute("xlink:type", "simple");
          this.xmlWr.writeAttribute("xlink:href", sHwww);  // the html or the pdf
          this.xmlWr.writeAttribute("text:style-name", "Internet_20_link");
          this.xmlWr.writeAttribute("text:visited-style-name", "Visited_20_Internet_20_Link");
          writeText("www", false);
          this.xmlWr.writeElementEnd("text:a");
          writeText(")", false);
        }
        writeText(" / ", false);
      }
      if(sHref !=null || sPDFref !=null || sPDFwww !=null) {
        this.xmlWr.writeElementInline("text:a");
        this.xmlWr.writeAttribute("xlink:type", "simple");
        this.xmlWr.writeAttribute("xlink:href", sPDFref == null ? sPDFwww == null ? sHref : sPDFwww : sPDFref);
        this.xmlWr.writeAttribute("text:style-name", "Internet_20_link");
        this.xmlWr.writeAttribute("text:visited-style-name", "Visited_20_Internet_20_Link");
        writeText(labelRef.sRefHeading, false);   //NOTE replace \\ etc. not done here
        if(sPDFref !=null || sPDFwww !=null ) {
          writeText(".pdf", false);
        } else {
          for(final String sLabel : labelRef.idxLabel.values()) {
            writeText(".html" + "#" + sLabel, false);
            break;  // use only the first label, usual only one
          }
        }
        this.xmlWr.writeElementEnd("text:a");
        //--------------------------------------------------- write the alternative www link also
        if(sPDFwww !=null && sPDFref !=null ) {
          writeText(" (", false);
          this.xmlWr.writeElementInline("text:a");
          this.xmlWr.writeAttribute("xlink:type", "simple");
          this.xmlWr.writeAttribute("xlink:href", sPDFwww);  // the html or the pdf
          this.xmlWr.writeAttribute("text:style-name", "Internet_20_link");
          this.xmlWr.writeAttribute("text:visited-style-name", "Visited_20_Internet_20_Link");
          writeText("www", false);
          this.xmlWr.writeElementEnd("text:a");
          writeText(")", false);
        }
      }
      writeText(": ", false);
      this.xmlWr.writeElementInline("text:span");
      this.xmlWr.writeAttribute("text:style-name", "Reference");
      writeText(labelRef.sTitle, false);   //NOTE replace \\ etc. not done here
      this.xmlWr.writeElementEndInline("text:span");
//        writeText(" page ", false);
//        writeText(labelRef.sPage, false);   //NOTE replace \\ etc. not done here
      
    } catch(Exception exc) {      //========================= should be used as template for all how to write unexpected Exceptions. 
      CharSequence sExc = ExcUtil.exceptionInfo("", exc, 0, 20);
      this.log.writef("\nException %s", sExc);
      sExc = ExcUtil.exceptionInfo("Exception: ", exc, 0, 2);
      this.xmlWr.writeElementInline("text:span");
      this.xmlWr.writeAttribute("text:style-name", "Emphasis");
      writeText("Exception: ", false);   //NOTE replace \\ etc. not done here
      writeText(sExc, false);   //NOTE replace \\ etc. not done here
      this.xmlWr.writeElementEndInline("text:span");
    }
    
  }
  
  
  
  
  /**Writes a page reference due to given &lt;:@page:sRef.> 
   * @param sRef can be empty or only consist of a max 3-digit number, 
   *   then it is ignored, instead the reference use on last called {@link #writeChapterRef(String)} is used here also.
   *   This is sensible if the &lt;:@page:.> follows after the &lt;:@ref:sRef:Title.>.
   *   If sRef is given, it can be used only for a page reference without reference text.
   * @throws IOException
   */
  private void writeInternalRefPage (String sRefArg) throws IOException {
    String sRef;
    ReadOdt.LabelRef extLabelRef = null;
    if(sRefArg == null || !sRefArg.startsWith("#")) {
      sRef = this.sRefBookmark;     // Note: Any sRefBookmark has the #. Maybe in future other designations.
    } else {                        //======================= similar algorithm as in writeInternalRef (...)
      sRef = sRefArg;
    }
    if(sRef == null) {
      this.log.writef("\nERROR <:@page.> without any <:@ref:... before");
      return;
    }
    sRef = sRef.substring(1);                              // use ist without starting "#..."
    extLabelRef = this.idxLabelExternRef.get(sRef);             // try fist with immediately given reference
    boolean bImgRef = sRef.startsWith("__Img_");           // Image refs should start with __Img_
    if(!bImgRef && !sRef.startsWith("__Link_")) {          // Chapter ref may start with __Link_ 
      sRef = "__Link_" + sRef;                             // nor __Img_ and _Link_: need the __Link_
    }
    if(extLabelRef == null) { 
      extLabelRef = this.idxLabelExternRef.get(sRef);
    }
    if(extLabelRef !=null) {               //---------------- write only the page number from the external ref
      this.xmlWr.writeElementInline("text:span");
      this.xmlWr.writeAttribute("text:style-name", "Reference");
      this.xmlWr.writeText(extLabelRef.sPage, false);
      this.xmlWr.writeElementEndInline("text:span");
    } else {                               //---------------- write a page bookmark ref to allow adjust page nr in LibreOffice
      this.xmlWr.writeElementInline("text:span");
      this.xmlWr.writeAttribute("text:style-name", "Reference");
      this.xmlWr.writeElementInline("text:bookmark-ref");
      this.xmlWr.writeAttribute("text:reference-format", "page");
      this.xmlWr.writeAttribute("text:ref-name", sRef);
      this.xmlWr.writeText("78", false);                   // only a dummy text will be replaced.
      this.xmlWr.writeElementEnd("text:bookmark-ref");
      this.xmlWr.writeElementEndInline("text:span");
    }
  }
  
  
  static String[] sWwwLink = {"www.", "http:", "https:"};
  
  
  
  private void writeLink(String sLink) throws IOException {
    String sRef;              // "theLink"
    String text;
    if(this.args.bReadAdoc) {
      int pos1 = sLink.indexOf('[');    //--------------------- link:theLink[theText]
      if(pos1 <0) {                                          //     "theLink[theText" := sLink
        this.xmlWr.writeText("link:" + sLink + "]", false);  // not able to resolve.
        sRef = null;
        text = null;
      } else {
        sRef = sLink.substring(0, pos1);              // "theLink"
        text = sRef;
      }
    } else {
      int pos1 = sLink.indexOf("::");
      if(pos1 >=0) {
        sRef = sLink.substring(0, pos1);
        text = sLink.substring(pos1+2);
      } else {
        sRef = text = sLink;
      }
    }
    if(sRef !=null) {
      if(StringFunctions.indexOfAnyString(sRef, 0, 6, sWwwLink, null, null) ==0) {  // sRef is an internet link: 0 = starts at pos 0 with "www..." etc.
        sRef = checkReplaceLinkOperationLabel(sRef);
      } else {
        int posFileEnd = sRef.indexOf(".html#");
        int posNameOperEnd;
        if(posFileEnd>0 && ( posNameOperEnd = sRef.indexOf("(...)")) >0)   {
          sRef = searchForReplaceLinkOperationLabel(sRef, posFileEnd+5, this.args.dirOut);
        }
        int posStartRealPath = StringFunctions.indexAfterAnyChar(sRef, 0, -1, "/.");
        this.lastAnchorReplaced = sRef.substring(posStartRealPath);
        if(sRef.startsWith("./")) {  //------------------------ ./relativ/link 
          sRef = "." + sRef;                               // changed to: ../relative/link necessary for LibreOffc
        } else {
          sRef = "../" + sRef;                  // add one directory level from inside odg to odg file level.
        }
      }
      this.xmlWr.writeElementInline("text:a");
      this.xmlWr.writeAttribute("xlink:type", "simple");
      this.xmlWr.writeAttribute("xlink:href", sRef);
      this.xmlWr.writeAttribute("text:style-name", "Internet_20_link");
      this.xmlWr.writeAttribute("text:visited-style-name", "Visited_20_Internet_20_Link");
      writeText(text, false);                 //Note: replace \\ etc. not done here.
      this.xmlWr.writeElementEnd("text:a");
    }
  }
  
  
  
  private String checkReplaceLinkOperationLabel ( String sRef) {
    String retRef = sRef;
    int posHashRef = sRef.indexOf('#');
    int posEllipsis = sRef.indexOf("...");
    if(posEllipsis >0)
      Debugutil.stop();
    if( (posHashRef >0 || posEllipsis >0) && this.lastAnchorReplaced.length()>0 && sRef.startsWith(this.args.swwwRoot)) {
      if(posEllipsis >0) {
        retRef = sRef.substring(0, posEllipsis) + this.lastAnchorReplaced;
      } else {
        int posHashRepl = this.lastAnchorReplaced.indexOf('#');
        String sFile = this.lastAnchorReplaced.substring(0, posHashRepl+1);
        int posFileWww = sRef.indexOf(sFile);                // the same file should be used
        if(posFileWww >0) {
          retRef = sRef.substring(0, posFileWww) + this.lastAnchorReplaced;
        }
      }
    }
    this.lastAnchorReplaced = "";  // always after next request, also on error. The next next is improper.
    return retRef;
  }
  
  
  /**Writes the pure text to XML, whereby spaces are replaced by &lt;text:s...>.
   * See also {@link #parseWriteText(String)}
   * @param txtArg
   * @param bNewline
   * @return
   * @throws IOException
   */
  private String writeText(CharSequence txtArg, boolean bNewline) throws IOException {
    StringBuilder sbText = null;
    CharSequence sText = txtArg;
//    if(StringFunctions.startsWith(txtArg, " is not true"))
//      Debugutil.stop();
//    if(txtArg.charAt(0)== ' ')
//      Debugutil.stop();
    if(sText instanceof StringBuilder) {
      sbText = (StringBuilder) sText;
    }
    int pos = -1;
    int zTxt = sText.length();
    pos = zTxt;
    int posw1 = 0, posw2 = posw1;
    //------------------------------------------------------- replace leading spaces because LOffc may ignore them on start of a line.
    // But if this is after span, one space is also replaced, though it might be unnecessary, but it works. 
    // the argument bNewline should designate, whether this is a writeText on start of line or not. Yet not used.
    // Do not remove this argument, may be necessary. Check whether this argument bNewline is ok. 
    while(posw2 < zTxt && sText.charAt(posw2) == ' ') { posw2 +=1; };
    if(posw2 > posw1) {
      this.xmlWr.writeElementInline("text:s");
      int nrSpaces = posw2 - posw1;  // LOffc: if text:c is not given on start of line, it is ok, if it is not given in the line, chaos.
      this.xmlWr.writeAttribute("text:c", "" + nrSpaces);  // seems to be that if not given, the same nrSpaces are written as the line.length, why ever?
      this.xmlWr.writeElementEnd("text:s");
      posw1 = posw2;
    }
    //while( (posw2 = StringFunctions.indexOfAnyChar(sText, posw1, -1, "\n\t")) >=0) {
    String[] findNlTabSpaces = {"\n", "\t", "  "};
    int[] nrFound = new int[1];
    while( (posw2 = StringFunctions.indexOfAnyString(sText, posw1, -1, findNlTabSpaces , nrFound, null)) >=0) {
      //char cWhat = sText.charAt(posw2);
      if(posw2 > posw1) {
        this.xmlWr.writeText(sText.subSequence(posw1, posw2), false);
      }
      switch( nrFound[0]) {
      case 0: {
        this.xmlWr.writeElementInline("text:line-break");
        this.xmlWr.writeElementEndInline("text:line-break");
      } break;
      case 1: {
        this.xmlWr.writeElementInline("text:tab");
        this.xmlWr.writeElementEndInline("text:tab");
      } break;
      case 2: {
        int posw3 = posw2;
        while(posw2 < zTxt && sText.charAt(posw2) == ' ') { posw2 +=1; }  //----- replace leading spaces only if the text should start in a newline.
        this.xmlWr.writeElementInline("text:s");
        int nrSpaces = posw2 - posw3;
        if(nrSpaces >1 ) { this.xmlWr.writeAttribute("text:c", "" + nrSpaces); }
        this.xmlWr.writeElementEnd("text:s");
        posw2 -=1;
      } break;
      default: // do nothing with
      } // switch
      posw1 = posw2 +1;
    }
    if(posw1 < sText.length()) {
      this.xmlWr.writeText(sText.subSequence(posw1, sText.length()), false);
    }
    if(pos< zTxt) {
      this.xmlWr.writeElementInline("text:s");
      if(pos < zTxt-1) { this.xmlWr.writeAttribute("text:c", "" + (zTxt-pos)); }
      this.xmlWr.writeElementEnd("text:s");
    }
    return null;
  }
  
  
  
  private CharSequence replaceBackslasSubscription(CharSequence txtArg, StringBuilder sbTextArg) {
    StringBuilder sbText = txtArg instanceof StringBuilder ? (StringBuilder) txtArg : sbTextArg;  // use a given unknown StringBuilder.
    CharSequence sText = txtArg;
//    if(sText.toString().contains("Note that a "))
//      Debugutil.stop();
    int pos = 0;
    int[] ixFound = new int[1];
    int ixTransscriptedInTextReplace = this.args.bReadAdoc ? 2 : 1;
    do {
      pos = StringFunctions.indexOfAnyString(sText, pos, 9999, sCheckTextReplVmu, ixFound, null);
      if(pos >=0) {
        if(sbText == null) {
          sbText = new StringBuilder(sText);
          sText = sbText;
        }
        String[] sRepl = sTextReplace[ixFound[0]];
        sbText.replace(pos, pos+sRepl[ixTransscriptedInTextReplace].length(), sRepl[0]);  // replace at position with non transcript text.
        pos += sRepl[0].length();                          // continue after replaced position.
      }
    } while(pos >=0);
    return sText;
  }
  
  
  private String XXXwriteCodeLine (String line) throws IOException {
    if(line.startsWith("----") && isEmptyLine(line,4)) {
      this.xmlWr.writeElementEnd("text:p");
      this.XXXnParagr -=1;
      this.sCodeStyle = null;
      this.bInsideCode = false;
    } else if(this.sCodeStyle !=null) {
      this.xmlWr.writeElement("text:p");
      this.xmlWr.writeAttribute("text:style-name", "Code" + this.sCodeStyle);
      writeText(line, false);
      this.bInsideCode = true;
      this.sCodeStyle = null;
    } else {
      this.xmlWr.writeElement("text:line-break");
      this.xmlWr.writeElementEnd("text:line-break");
      writeText(line, false);
    }
    return null;
  }
    
  
 
  
  /**Writes a block as code, write each line as extra &lt;text:p....
   * The content of lines are evaluated with {@link #parseWriteText(String)}.
   * It means, also here character mark up (span) and character replacements 
   * ({@link #replaceBackslasSubscription(CharSequence, StringBuilder)} are also done here.
   * <br>
   * <br>
   * A line starting with &lt;:include:PATH/TO/File::tag> includes a source part,
   * see {@link #includeSrcCode(String)}.
   *  
   * @param sStartLine first line of code block, containing the &lt;:Code....
   * @return
   * @throws IOException
   */
  private String parseWriteCodeBlock (String sStartLine) throws IOException {
    if(!this.args.bReadAdoc) {
      int pos1 = sStartLine.indexOf(':', 2);
      int pos2 = sStartLine.indexOf('>');
      if(pos2 == pos1+1)
        Debugutil.stop();
      if(pos1 >0 && pos2 > pos1) {
        this.sCodeStyle = "Code" + sStartLine.substring(pos1+1, pos2);
      } else {
        this.sCodeStyle = "Code";
        this.log.writeError("WARNING faulty %s\n", sStartLine);
      }
    }
    String sLineNext;
    sLineNext = this.rAdoc.readLine();
//    if(sLineNext.contains("<\\:pageBreak.\\>"))
//      Debugutil.stop();
//    if(sLineNext.contains("void calc_ifFB"))
//      Debugutil.stop();
    do {
//      if(sLineNext.contains("Condition Bits"))
//        Debugutil.stop();
      if(sLineNext.startsWith("<:include:")) {
        includeSrcCode(sLineNext.substring(2));
      } else if(sLineNext.startsWith("<::include:")) {
        includeSrcCode(sLineNext.substring(3));
      } else if(sLineNext.startsWith("<.Code")|| this.args.bReadAdoc && sLineNext.startsWith("----")) {
        break;
      } else {
        this.xmlWr.writeElement("text:p");
        this.xmlWr.writeAttribute("text:style-name", this.sCodeStyle);
        parseWriteText(sLineNext, false);    // ==============>> parseWriteText() interpret text formatting also in code blocks.
        //writeText(sLineNext, true);           // ============>> writeText as given, without interpretation.
        this.xmlWr.writeElementEndInline("text:p");
      }
      sLineNext = this.rAdoc.readLine();
    } while(sLineNext !=null);
    this.sCodeStyle = null;
    this.bInsideCode = false;
    return null;
  }
    
  
  
  /**Includes lines from a source file. Syntax:<pre>
   * &lt;include:../path/to/src::TAG::44::2,4:txt,5.> </pre>
   * <ul>
   * <li>'TAG' is the tag searched in the source.
   * <li>first number '44' is the max line length, src lines are shorten and ends with ... if necessary
   * <li>second '2,4:txt,5' are numbers and optional text in which line marker with '1'... or 'text' are positioned
   * </ul>
   * Source:<ul>
   * <li> &lt::TAG.> If contains anywhere in the line, this is the first line to get.
   * <li> &lt::~TAG.> If contains anywhere in the line, the next line is the first line to get.
   * <li> &lt.TAG.> Marked with this, it is the last line to contain, then include is stopped.
   * <li> &lt.~TAG.> Marked with this, from this line include is stopped.
   * <li> &lt:-TAG> This line and following are omitted and replaced by " ....."
   * <li> &lt:+TAG> from this line insertion is recovered
   * <li> Markers can also contain in the source in the form <:marker.>
   * </ul>
   * @param sLineIncl
   * @throws IOException 
   */
  private void includeSrcCode (String sLineIncl) throws IOException {
    if(sLineIncl.contains("makeDocu/-Loffc_odt2Zml.bat::java"))
      Debugutil.stop();
    CodeIncludeInfo info = new CodeIncludeInfo(sLineIncl);
    this.xmlWr.writeElement("text:p");        //------------- write head information 'include:path::TAG::44:1:M'
    String style = this.bPageBreakBefore ? "CaptionCodePg" : this.bColumnBreakBefore ? "CaptionCodeCol" : "CaptionCode";
    this.bPageBreakBefore = this.bColumnBreakBefore = false;
    this.xmlWr.writeAttribute("text:style-name", style);
    this.xmlWr.writeText(info.sLineIncl, false);
    this.xmlWr.writeElementEndInline("text:p");
    File fIncl = new File(info.sFile);
    BufferedReader frIncl;
    try {
      frIncl = new BufferedReader(new InputStreamReader(new FileInputStream(fIncl)));
    } catch(FileNotFoundException exc) {
      frIncl = null;
      this.xmlWr.writeElement("text:p");        //------------- write head information 'include:path::TAG::44:1:M'
      this.xmlWr.writeAttribute("text:style-name", "CaptionCode");
      this.xmlWr.writeText("File not found: >>" + info.sFile + "<< " + fIncl.getAbsolutePath() , false);
      this.xmlWr.writeElementEndInline("text:p");
      this.log.writef("\nERROR file not found: %s",info.sFile);
    }
    if(frIncl !=null) {
      String sLine;
      boolean bTag = info.sTag.equals("$");                //tag '$', include all.
      boolean bEndTag = false;
      String sTagSearch = "<::" + info.sTag + ".>";
      String sTagSearchNext = "<::~" + info.sTag + ".>";
      String sTagEndThis = "<:.~" + info.sTag + ".>";
      String sTagEnd = "<:." + info.sTag + ".>";
      String sTagPause = "<:-" + info.sTag + ".>";
      String sTagCont = "<:+" + info.sTag + ".>";
      Iterator<CodeIncludeInfo.MarkerLine> iterMarkerLine = info.markerLines == null ? null: info.markerLines.iterator();
      CodeIncludeInfo.MarkerLine markerLine = iterMarkerLine == null ? null : iterMarkerLine.next();
      int nLine = bTag ? 0 : -1;
      int markerColumn = 0;
      while( !bEndTag && (sLine = frIncl.readLine()) !=null) {
        String sText;
        int posTag;
        String sMarker = null;
        if(nLine >=0) { 
          nLine +=1; 
          if(markerLine !=null && markerLine.line == nLine) {
            sMarker = markerLine.marker;
            markerColumn = markerLine.column;
            markerLine = iterMarkerLine == null || !iterMarkerLine.hasNext() ? null : iterMarkerLine.next();
          }
        }
        if(!bTag) {
          if((posTag = sLine.indexOf(sTagSearch)) >=0) {
            bTag = true;
            nLine = 1;
            sText = sLine.substring(0, posTag);
          } else if(sLine.indexOf(sTagSearchNext) >=0) {
            bTag = true;
            sText = null;
          } else if( (posTag = sLine.indexOf(sTagCont)) >=0
                  || sMarker !=null && sMarker.equals("+")
                     && (posTag = sLine.length()) >0
                  ) {
            bTag = true;
            sText = sLine.substring(0, posTag);
            sMarker = null;    // remove the "+", not a marker
          } else {
            sText = null;
          }
        } 
        else if((posTag = sLine.indexOf(sTagEnd)) >=0) {
          bEndTag = true;                      // finish file
          sText = sLine.substring(0, posTag);
        } else if((posTag = sLine.indexOf(sTagEndThis)) >=0) {
            bEndTag = true;                      // finish file
            sText = null;
        } else if(  (posTag = sLine.indexOf(sTagPause)) >=0
                 || sMarker !=null && sMarker.equals("-")) {
          sText = "    ......";
          bTag = false;
          sMarker = null;
        } else {
          sText = sLine;
        }
        if(sText !=null) {
          if(sMarker !=null) {
            Debugutil.stop();
          }
          int posMarker = info.maxLineLen;  // important if sMarker is already set by VML
          if( sMarker == null && (posMarker = sLine.indexOf("<:@")) >=0) {
            int pos2 = sLine.indexOf(".>", posMarker+3);
            if(pos2 <0) { pos2 = sLine.indexOf('>', posMarker+3); }
            if(pos2 >0) {
              sMarker = sLine.substring(posMarker+3, pos2);
            }
          }
          int length = sText.length();
          int lenLine2;
          if(sMarker == null) { lenLine2 = info.maxLineLen; }
          else {
            lenLine2 = info.maxLineLen - sMarker.length();      // marker should have place right.
            if(lenLine2 > posMarker) { lenLine2 = posMarker; }  // line till max the marker, it is right side.
          }
          while(length > lenLine2 && sText.charAt(length-1) == ' ' ) {
            length -=1;                                    // if has unused spaces on end, shorten the spaces.
          }
          if(length > lenLine2) {
            sText = sLine.substring(0, lenLine2 -3) + "...";
          }
          this.xmlWr.writeElement("text:p");
          this.xmlWr.writeAttribute("text:style-name", this.sCodeStyle);
          writeText(sText, false);
          if(sMarker !=null) {
            if(length < markerColumn) {
              int nSpaces = markerColumn - length;         // wr line ....spaces.... <MARKER> due to markerColumn
              this.xmlWr.writeElementInline("text:s");
              this.xmlWr.writeAttribute("text:c", "" + nSpaces);
              this.xmlWr.writeElementEnd("text:s");
            }
            this.xmlWr.writeElementInline("text:span");
            this.xmlWr.writeAttribute("text:style-name", "cM");
            this.xmlWr.writeText(sMarker, false);                // do not check content again, write text inside span as given. 
            this.xmlWr.writeElementEnd("text:span");
          
          }
          this.xmlWr.writeElementEndInline("text:p");
        }
      }
      if( !bTag && info.sTag !=null) {
        this.log.writef("Problem with source include from '%s', tag '%s' not found", info.sFile, info.sTag);
      }
      if(! bEndTag && info.sTag !=null && !info.sTag.equals("$")) {
        this.log.writef("Problem with source include from %s with tag=", info.sFile, info.sTag);
      }
      frIncl.close();
    }
  }
  
  
  
  
  private String writeTableOfContents (String line) throws IOException {
    XXXfinitParagr();
    finitList(0);
    int posChapter = line.indexOf("chapter-");
    int posDeepness = posChapter >=0 ? posChapter + 8 : 0;
    int nDeepness = StringFunctions_C.parseIntRadix(line, posDeepness, 9999, 10, null);
    if(nDeepness ==0) return "ERROR " + line;
    int posColon = line.indexOf(':');
    String sTitle = posColon >0 ? line.substring(posColon +1).trim() : "Table of Contents"; 
//    this.xmlWr.writeElement("text:section");
//    this.xmlWr.writeAttribute("text:style-name", "SectTOC");
//    this.xmlWr.writeAttribute("text:name", "content");
    //
    this.xmlWr.writeElement("text:table-of-content");
    this.xmlWr.writeAttribute("text:style-name", "SectTOCc");
    this.xmlWr.writeAttribute("text:protected", "true");
    //this.xmlWr.writeAttribute("text:name", "TOC1");
    //
    this.xmlWr.writeElement("text:table-of-content-source");
    this.xmlWr.writeAttribute("text:outline-level", "" + nDeepness);
    if(posChapter >=0) {
      this.xmlWr.writeAttribute("text:index-scope", "chapter");
    }
    //
    this.xmlWr.writeElement("text:index-title-template");
    this.xmlWr.writeAttribute("text:style-name", "Contents_20_Heading");
    this.xmlWr.writeText(sTitle, false);
    this.xmlWr.writeElementEnd("text:index-title-template");
    //
    this.xmlWr.writeElementEnd("text:table-of-content-source");
    //
    this.xmlWr.writeElement("text:index-body");
    this.xmlWr.writeElement("text:index-title");
    this.xmlWr.writeElement("text:p");
    String style = this.bPageBreakBefore ? "Contents_20_Heading_pg" : this.bColumnBreakBefore ? "Contents_20_Heading_col" : "Contents_20_Heading";
    this.bPageBreakBefore = this.bColumnBreakBefore = false; // flag is only for this paragraph
    this.xmlWr.writeAttribute("text:style-name", style);
    this.xmlWr.writeText(sTitle, false);
    this.xmlWr.writeElementEndInline("text:p");
    this.xmlWr.writeElementEnd("text:index-title");
    this.xmlWr.writeElementEnd("text:index-body");
    //
    this.xmlWr.writeElementEnd("text:table-of-content");
//    this.xmlWr.writeElementEnd("text:section");

    return null;
  }
  
  
  
  /**Writes a list of external references with the labels.
   * For that the odt should contain the paragraph styles 'ExternRefTitle' and 'ExternRefList'.
   * It is not necessary and only activated with the command line option '-extRefs'.
   * The information are also contained in the files due to the option '-labels:*.Labels.txt'.
   * @throws IOException
   */
  private void writeExternReferences () throws IOException {
    String sFile = "?";
    for(ReadOdt.LabelRef labelRef : this.idxChnrExternRef.values()) {
      if(!labelRef.sRefHeading.equals(sFile)) {            // contains the file name
        this.xmlWr.writeElement("text:p");
        this.xmlWr.writeAttribute("text:style-name", "ExternRefTitle");
        writeText("Docu file: ", false);
        writeText(labelRef.sRefHeading, false);
        this.xmlWr.writeElementEndInline("text:p");
        sFile = labelRef.sRefHeading;
      }
      for(String sLabel : labelRef.idxLabel.values()) {
        this.xmlWr.writeElement("text:p");
        this.xmlWr.writeAttribute("text:style-name", "ExternRefList");
        this.xmlWr.writeElementInline("text:bookmark-start");
        this.xmlWr.writeAttribute("text:name", "__Link_" + sLabel);
        this.xmlWr.writeElementEnd("text:bookmark-start");
        String sTitle = labelRef.sTitle;
        int posNrEnd = sTitle.indexOf(' ');
        if(posNrEnd >0) {                                  // replace first space with tab
          sTitle = sTitle.substring(0, posNrEnd) + '\t' + sTitle.substring(posNrEnd+1);
        }
        writeText(sTitle, false);
        writeText(" page ", false);
        writeText(labelRef.sPage, false);
        writeText(" (#", false);
        writeText(sLabel, false);
        writeText(")", false);
        this.xmlWr.writeElementInline("text:bookmark-end");
        this.xmlWr.writeAttribute("text:name", "__Link_" + sLabel);
        this.xmlWr.writeElementEnd("text:bookmark-end");
        this.xmlWr.writeElementEndInline("text:p");
      }
    }
    return;
  }
  
  private void XXXfinitParagr() throws IOException {
    assert(this.XXXnParagr ==0);
    while(--this.XXXnParagr >=0) {
      this.xmlWr.writeElementEndInline("text:p");                    // write </text:p> etc. to finish paragraph in odt
    }
    this.XXXnParagr = 0;
  }

  private void finitList( int nList) throws IOException {
    while(this.nList > nList) {
      if(this.bInsideListItem) {
        this.xmlWr.writeElementEnd("text:list-item");
      }
      this.bInsideListItem = false;
      this.xmlWr.writeElementEnd("text:list");
      this.nList -=1;
    }
  }

  
  private void finitSection(int toLevel) throws IOException {
    finitList(0);
    while(this.nSection >toLevel) {
      this.xmlWr.writeElementEnd();                    // write </text:p> etc. to finish paragraph in odt
      this.nSection -=1;
    }
    
  }

  
  
  
  private String parseWriteTable(String line) throws IOException {
    String error = null;
    int posColon = line.indexOf(':', 2);
    int posEnd = line.indexOf('>');
    if(posEnd <0) return "missing > on <::table";
    String nrCol = "2";
    while( posColon >=0 && posColon < posEnd) {  //---------- read some attributes of a table
      int posColonNext = line.indexOf(':', posColon+1);
      if(posColonNext <0 || posColonNext > posEnd) {
        posColonNext = posEnd;
      }
      String sAttr = line.substring(posColon+1, posColonNext).trim();
      if(sAttr.startsWith("col=")) { nrCol = sAttr.substring(4); }   //:col= number of columns
      posColon = posColonNext;
    }
    this.xmlWr.writeElement("table:table");
    this.xmlWr.writeAttribute("table:name", "Table" + (++this.nrTableName));
    this.xmlWr.writeAttribute("table:style-name", "Table1");
    this.xmlWr.writeAttribute("table:template-name", "Elegant");
    this.xmlWr.writeElement("table:table-column");
    this.xmlWr.writeAttribute("table:style-name", "Table1.A");
    this.xmlWr.writeAttribute("table:number-columns-repeated", nrCol);
    this.xmlWr.writeElementEnd("table:table-column");
    String sLineNext;
    boolean bInTable = true;
    while ( error == null && bInTable && (sLineNext = this.sLineNext !=null ? this.sLineNext : this.rAdoc.readLine()) !=null) {
      this.sLineNext = null;  //used
      sLineNext = sLineNext.trim();
      if(isEmptyLine(sLineNext,0)) {                       // an empty line is the end of the paragraph
      } 
      else if(sLineNext.startsWith("<.table>")){
        bInTable = false;
      }
      else if(sLineNext.startsWith("<:tr.>")){
        error = parseTableRow(sLineNext.substring(6));
      }
    }
    this.xmlWr.writeElementEnd("table:table");
    return error;  
  }

  
  
  private String parseTableRow(String line) throws IOException {
    String error = null;
    this.xmlWr.writeElement("table:table-row");
    this.xmlWr.writeAttribute("table:style-name", "Table1.A");
    String sLineNext;
    boolean bInRow = true;
    while ( bInRow && (sLineNext = this.sLineNext !=null ? this.sLineNext : this.rAdoc.readLine()) !=null) {
      this.sLineNext = null;   //used
      sLineNext = sLineNext.trim();
      if(isEmptyLine(sLineNext,0)) {                       // an empty line is the end of the paragraph
      } 
      else if(sLineNext.startsWith("<.table>") || sLineNext.startsWith("<:tr.>")){
        bInRow = false;
        this.sLineNext = sLineNext;
      }
      else if(sLineNext.startsWith("<:td")){
        this.xmlWr.writeElement("table:table-cell");
        this.xmlWr.writeAttribute("table:style-name", "Table1.A1");
        this.xmlWr.writeAttribute("office:value-type", "string");
        int pos2 = sLineNext.indexOf(".>");
        int pos9 = pos2 +2;
        if(pos2 <0) { pos2 = sLineNext.indexOf(".>"); pos9 = pos2 +1; }
        if(pos2 <0) return "ERROR missing > in <:td...";
        int pos3 = sLineNext.indexOf(":spanned=");
        if( pos3>=0) {
          String spanned = sLineNext.substring(pos3+9, pos2).trim(); 
          this.xmlWr.writeAttribute("table:number-columns-spanned", spanned);
        }
        int posP = sLineNext.indexOf("<:p:");
        if(posP >0) { parseWriteParagrStyleLabel(sLineNext.substring(posP)); }
        else { parseWriteParagr(sLineNext.substring(pos9), null); }
        this.xmlWr.writeElementEnd("table:table-cell");
      }
    }
    this.xmlWr.writeElementEnd("table:table-row");
    return error;
  }

  
  
  
  
  
  /**Writes an image with given arguments from the span <:args.>
   * @param args starts with the path to the image, contains all after "<:image:"
   * @param bOnlyImage true then the paragraph contains only the image.
   *   Note in LibreOffice an image is always embedded in a paragraph.
   * @return null if no error
   * @throws IOException
   */
  private String parseImage(String args, boolean bOnlyImage) throws IOException{
    if(args.contains("exmpTrueFalseComplex_ifFB.png"))
      Debugutil.stop();
    String error = null;
    String sSepAttribs = this.args.bReadAdoc ? "," : "::";
    int zSepAttribs = sSepAttribs.length();
    int pos2 = this.args.bReadAdoc ? args.indexOf('[') : args.indexOf(sSepAttribs);
    int posAttribs;
    if(this.args.bReadAdoc) {
      if(pos2 <0) return "image:: without []";
      posAttribs = args.charAt(pos2+1) == ']' ? 0 :pos2+1;
    } else {
      if(pos2 <0) { pos2 = args.length(); args.indexOf('>'); posAttribs = 0; }
      else { posAttribs = pos2 + zSepAttribs; }
      if(pos2 <0) return "ERROR <image:... without >";
    }
    //if(line.indexOf(this.args.bReadAdoc ? ']' : '>') <0) return "image:: right ] missing";
    int posLink = this.args.bReadAdoc ? 7 : 0;// 8;
    String sLink = args.substring(posLink, pos2).trim();
    String sId = null;
    String sX = null;
    String sY = null;
    String pX=null, pY=null;
    String DPIx="150", DPIy="150";   //default 150 DPI means 1024 x 768 ~ 6in*4.5in = 15cm*12cm
    String sTitle = null;
    String styleImg = null;
    boolean bFloat = false;
    int nrArg = 0;
    while(posAttribs >0) {
      nrArg +=1;
      int pos4 = args.indexOf('=', posAttribs);
      if(pos4 <0) pos4 = args.length();
      String key = args.substring(posAttribs, pos4).trim();
      int pos5 = args.indexOf(sSepAttribs, pos4);
      if(pos5 <0 ) { 
        pos5 = args.length();
        posAttribs = -1;         //last
      } else {
        posAttribs = pos5 + zSepAttribs;
      }
      String value = args.substring(pos4+1, pos5).trim();
      int posXy = value.indexOf('*');   // separator between x and y
      if(key.equals("id")) {
        sId = null; //value;
      }
      else if(key.equals("size")) {
        if(posXy >0) {
          sX = value.substring(0,posXy).trim();
          sY = value.substring(posXy+1).trim();
        } else {
          sX = value; sY = null;
        }
      }
      else if(key.equals("px")) {
        if(posXy >0) {
          pX = value.substring(0,posXy).trim();
          pY = value.substring(posXy+1).trim();
        } else {
          pX = pY = value;
        }
      }
      else if(key.equals("DPI")) {
        if(posXy >0) {
          DPIx = value.substring(0,posXy).trim();
          DPIy = value.substring(posXy+1).trim();
        } else {
          DPIx = DPIy = value;
        }
      }
      else if(key.equals("width")) {
        sX = value;
      }
      else if(key.equals("height")) {
        sY = value;
      }
      else if(key.equals("title")) {
        sTitle = replaceBackslasSubscription(value, null).toString();
      }
      else if(key.equals("float")) {
        styleImg = "ImageFloat" + value;
        bFloat = true;
      }
      else if(key.equals("style")) {
        styleImg = value;
      }
      else if(nrArg == 1){
        sTitle = key;
      } 
      else if(key.equals("anchor")) {
        
      }
      else if(key.equals("sRelX")) {
        
      }
      else if(key.equals("sRelY")) {
        
      }
      else {
        Debugutil.stop();
      }
    }
    if(sTitle !=null && sTitle.startsWith(this.cfg.sImgCaptionStart)) {  //reduce the sTitle if is contains the standard pre text "Image 12: "
      int posEnd = sTitle.indexOf(this.cfg.sImgCaption2);  // the standard pre text will be completed later again, maybe with another number!
      if(posEnd >0) {
        sTitle = sTitle.substring(posEnd + this.cfg.sImgCaption2.length());
      } else {
        //reduce sTitle if not start with pre text, nothing to do.
      }
      
    }
    if(styleImg == null) { styleImg = "ImageCenter"; }
    String[] sLinkUse = new String[1];
    final File fImg;
    if(this.args.bRenameImageFiles && sTitle !=null) {
      fImg = checkAndChangeFileImage(sLinkUse, this.args.dirOut, sLink, sTitle);
    } else {
      fImg = new File(this.args.dirOut, sLink);
      sLinkUse[0] = sLink;
    }
    sLink = sLinkUse[0];
    if(sLink.startsWith("./")) {
      sLink = "." + sLink;
    } else if(sLink.startsWith("../")) {
      sLink = "../" + sLink;
    } else {
      // do nothing for absolute link or link inside odt.
    }
    int[] nChars = new int[1];
    float nX =0, nY =0; String sMeas = null;
    if(sX !=null) {
      nX = StringFunctions_C.parseFloat(sX, 0, 99, nChars);
      sMeas = sX.substring(nChars[0]);
    }
    if(sY !=null) {
      nY = StringFunctions_C.parseFloat(sY, 0, 99, nChars);
      sMeas = sY.substring(nChars[0]);
    }
    if(sMeas == null) { sMeas = "in"; }
    float nScale = 1.0f;  // scale from inches to given unit. 
    if(sMeas.equals("cm")) { nScale = 2.54f; }
    else if(sMeas.equals("mm")) { nScale = 25.4f;  }
    else if(sMeas.equals("pt")) { nScale = 72; }
    else if(sMeas.equals("in")) { nScale = 1.0f; }
    else if(sMeas.equals("Pica")) { nScale = 6; }
    float dyFrame = 0.25f * nScale;
    String sYframe;
    if(sX == null || sY == null) {     //-------------------- The image size is not given:
      if(pX == null || pY == null) {
        if(fImg.exists()) {              //-------------------- read it from the real exist image.
          BufferedImage myPicture = ImageIO.read(fImg);
          WritableRaster raster = myPicture.getRaster();
          pX = "" + raster.getWidth();
          pY = "" + raster.getHeight();
        } else {
          pX = "1024";
          pY = "768";
        }
      }
      float npX = StringFunctions_C.parseIntRadix(pX, 0, 99, 10, null);
      float npY = StringFunctions_C.parseIntRadix(pY, 0, 99, 10, null);
      int nDPIx = StringFunctions_C.parseIntRadix(DPIx, 0, 99, 10, null);
      int nDPIy = StringFunctions_C.parseIntRadix(DPIy, 0, 99, 10, null);
      if(nX >0) {   //--------------------------------------- The width is given, it is often, 
        nY = nX * npY/npX;                                 // sY from given sX and natural relation of the image
      } else {
        nX = npX / nDPIx;                                  // sX, sY via given pixel and DPI
        nY = npY / nDPIy;
      }
    }
    if(nX > 7.1f * nScale) {
      nY = 7.1f * nScale / nX * nY;
      nX = 7.1f * nScale;                      // A4 site width
      sX = null; sY = null;  // to build newly
    }
    if(sX == null) { sX = String.format(Locale.ENGLISH, "%2.2f%s",nX, sMeas); }
    if(sY == null) { sY = String.format(Locale.ENGLISH, "%2.2f%s",nY, sMeas); }
    sYframe = String.format(Locale.ENGLISH, "%2.2f%s", (nY + dyFrame), sMeas);
//    String styleFrame = "Frame" + style.substring(3);
    this.bPageBreakBefore = this.bColumnBreakBefore = false; // flag is only for this paragraph
    this.nrFrameImgName +=1;
    //this.xmlWr.writeElement("draw:frame");
    //this.xmlWr.writeAttribute("draw:style-name", style);
    //this.xmlWr.writeAttribute("draw:name", "Frame" + (this.nrFrameImgName));
    //String sAnchor = bOnlyImage ? "as-char" : "paragraph";  // assign to character "char" produces only one line height in the paragraph
    String sAnchor = "paragraph";  // assign to character "char" produces only one line height in the paragraph
    //this.xmlWr.writeAttribute("text:anchor-type", sAnchor);
    //this.xmlWr.writeAttribute("svg:width", sX);
    //this.xmlWr.writeAttribute("svg:height", sYframe);
    //this.xmlWr.writeElement("draw:text-box");
    //this.xmlWr.writeElement("text:p");
    //this.xmlWr.writeAttribute("text:style-name", "Figure");
    if(bOnlyImage) {
      assert(this.sStyleParagr !=null);
      String sStyle = "ImgCaption" + this.sStyleParagr; //"Text"; //"Text" or "TextPg" or "TextCol"
//      if(this.bBreakBefore) {
//        sStyle += this.bInsideColumn2 ? "Col" : "Pg";
//      }
      this.xmlWr.writeAttribute("text:style-name", sStyle);
      this.sStyleParagr = null;
    }
    this.xmlWr.writeElement("draw:frame");
    this.xmlWr.writeAttribute("draw:name", "Image" + this.nrFrameImgName);
    this.xmlWr.writeAttribute("draw:style-name", styleImg);
    //this.xmlWr.writeAttribute("text:anchor-type", "paragraph");  // inside the frame image to the paragraph which is the caption text
    this.xmlWr.writeAttribute("text:anchor-type", sAnchor);  // inside the frame image to the paragraph which is the caption text
    //this.xmlWr.writeAttribute("svg:x", "0in");
    //this.xmlWr.writeAttribute("svg:y", "0in");
    this.xmlWr.writeAttribute("svg:width", sX);
    this.xmlWr.writeAttribute("svg:height", sY);
    this.xmlWr.writeElement("draw:image");
    this.xmlWr.writeAttribute("xlink:href", sLink);
    this.xmlWr.writeAttribute("xlink:type", "simple");
    this.xmlWr.writeAttribute("xlink:show", "embed");
    this.xmlWr.writeAttribute("xlink:actuate", "onLoad");
    this.xmlWr.writeAttribute("draw:mime-type", "image/png");
    this.xmlWr.writeElementEnd("draw:image");  //draw:image
    this.xmlWr.writeElementEnd("draw:frame"); //draw:frame
//    this.xmlWr.writeElementInline("text:bookmark-start");
//    this.xmlWr.writeAttribute("draw:name", "__RefNumPara__" + sId);
//    this.xmlWr.writeElementEnd("text:bookmark-start");
    this.bParagrFirstline = true;
//    writeText(sTitle, false);
//    this.xmlWr.writeElementInline("text:bookmark-end");
//    this.xmlWr.writeAttribute("draw:name", "__RefNumPara__" + sId);
//    this.xmlWr.writeElementEnd("text:bookmark-end"); //text:bookmark-end
//    this.xmlWr.writeElementEndInline("text:p"); //draw:h
//    this.xmlWr.writeElementEnd("draw:text-box"); //draw:h
//    this.xmlWr.writeElementEnd("draw:frame"); //draw:h
    if(!bFloat) {
      Debugutil.stop();
//      this.xmlWr.writeElementInline("text:line-break");
//      this.xmlWr.writeElementEnd("text:line-break");
    }
    String sBookmark;
    if(sId == null) {                       //--------------- id not given in VML:
      int posName = sLink.lastIndexOf('/') +1;             // then build automatically the bookmark only from the file name.
      int posDir = sLink.lastIndexOf('/', posName-2) +1;   // optional with the dir before it is not "./" or "../"
      int posExt = sLink.lastIndexOf('.');                 
      if(posDir >0 && sLink.charAt(posDir) !='.') {
        sBookmark = "__Img_" + sLink.substring(posDir, posName-1) + "_" + sLink.substring(posName, posExt);
      } else {
        sBookmark = "__Img_" + sLink.substring(posName, posExt);
      }
    } else if(sId.startsWith("__Img")) {    //--------------- a given user Id "__img_..."
      sBookmark = sId;
    } else {                                //--------------- a given user Id
      sBookmark = "__Img_" + sId;                          // the bookmark for images should always start with __Img
    }
    String sBookmark1 = sBookmark;
//    int nrBookmark = 0;
//    while(this.idxBookmark.get(sBookmark) !=null) {
//      sBookmark = sBookmark1 + "_" + (++nrBookmark); 
//    }
//    this.idxBookmark.put(sBookmark, sBookmark);
    if(bOnlyImage) {
      StringBuilder sCap = new StringBuilder(100);
      sCap.append(this.cfg.sImgCaptionStart);
      if(this.cfg.eImgKindNr == 1) {
        sCap.append(this.nrFrameImgName);
      }
      sCap.append(this.cfg.sImgCaption2);
      if(sTitle !=null) {
        sCap.append(sTitle);
      }
      this.xmlWr.writeElementInline("text:bookmark-start");
      this.xmlWr.writeAttribute("text:name", sBookmark);
      this.xmlWr.writeElementEnd("text:bookmark-start");
      this.xmlWr.writeText(sCap, false);
      this.xmlWr.writeElementInline("text:bookmark-end");
      this.xmlWr.writeAttribute("text:name", sBookmark);
      this.xmlWr.writeElementEnd("text:bookmark-end"); //text:bookmark-end
    } else {
    }
    wrRep("  " + sBookmark + ": " + sTitle);
    return error;
  }
  

  
  private File checkAndChangeFileImage (String[] sLinkUse, File dirOdt, String sLink, String sTitle) {
    sLinkUse[0] = sLink;                                   //default
    File fLink = new File(dirOdt, sLink);
    if(sTitle == null) return fLink ;
    int posName = sLink.lastIndexOf('/')+1;
    int posExt = sLink.lastIndexOf('.');
    int posEndTitleFile = StringFunctions.indexOfAnyChar(sTitle, 0, -1, ": ;&");
    if(posEndTitleFile <0) { posEndTitleFile = sTitle.length(); }
    int posExtTitle = sTitle.lastIndexOf('.', posEndTitleFile);
    if( posExtTitle >0 && posEndTitleFile > posExtTitle+1                 // sTitle has the form of a filename.ext: till faultyChars 
     && sLink.substring(posExt).equals(sTitle.substring(posExtTitle, posEndTitleFile))  // title contains the same extension
      ) {
     String sTitleFileName = sTitle.substring(0, posEndTitleFile);
      String sTitleFile = sLink.substring(0, posName) + sTitleFileName;
      File fLinkTitle = new File(dirOdt, sTitleFile);
      if(fLinkTitle.exists()) {
        sLinkUse[0] = sTitleFile;
        return fLinkTitle;                                 // The file name is taken from sTitle, exists.
      } else {
        if(fLink.exists()) {
          if(fLink.renameTo(fLinkTitle)) {                 // success renamed the linked file.
            sLinkUse[0] = sTitleFile;
            return fLinkTitle;
          }
        }
      }
    }
    return fLink;
  }
  
  
  


}
